      SUBROUTINE conacsf(FUL,EC,KSTHE,NSTHE,IOP,NOP,FUH,LSJ)
C    ***********************************************************
C
C        CALCULATION OF CORE STRENGTH FUNCTION TO 3-B CONTINUUM                       
C    ********* CREATION DATE  11-3-95 CHANGES: 17 Nov 1995 (IJT)
C					       10 Oct 1998 (IJT+BD)
C
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAYs KSTGS,KSTHE
C
c ------------ LI - bound     (initial) State
c ------------ HE - continuum (final)   State
c
C        CORE STRENGTH FUNCTION TO 3-B CONTINUUM  ARE in  FUR(*)
	use parameters
	use globals
	use gs
	use scattering
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL FIRST

      COMPLEX*8 SU,FUR(MCHAN3)
C
      DIMENSION KSTHE(MCHAN3,7)
      COMPLEX*16 FUH(MNOP,MCHAN3,NMAXF)
      DIMENSION FUL(nstgs,NMAXF),IOP(NOP)
      INTEGER PHASE

C *******************************************************************
c ---------  Reynal-Revai Coefficients
C
      COMMON/ROT/C,S,T,A(99,29),JO11,JO12
      COMMON/MASES/A111,A222,A333

       DIMENSION SH(MCHAN3),RRCLI(30,30),RRCHE(30,30)
     * ,L1LIM(30,30),L2LIM(30,30),L1HEM(30,30),L2HEM(30,30)

C########################################################### for STURMR:
      NX = numrs
      DR = steps
	if(glag) NX = numr
      IMAGS = numr
!				Get information from globals for local use:
!				Assumes 1,2 are nucleons, 3 is core!
	A1 = mass(1)
	A2 = mass(2)
	A3 = mass(3)

C    *** Number of hyperangle points
C
      NIKZEN=20

C    *** Regularisation radius for 1/rho^3 for monopole transitions
C
      RHOSE = 5d0

	JLI = nint(JTOTI)
	IPLI= PARITI
	ITLI = TTGS

	JHE  = nint(JTOT)
	IPHE = PARITY
	ITHE = TT

	FIRST = LSJ.eq.0
	if(FIRST) then
	  call chops(210)
	  WRITE(210,151) JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PARITY+2)
151       FORMAT('# Summed core dS/dE for J=',f5.1,A1,' ->',f5.1,A1)
	  WRITE(159,1511) JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PARITY+2)
1511       FORMAT(f5.1,A1,' ->',f5.1,A1,' core transition ',
     x			'amplitudes')
	  endif
	dSdE = 0d0
c
c *****  Calcul. all lsj transitions for Ji -> Jf (+parity)
c
	        LSJ = 0

	DO 1200 JTR=nint(abs(JTOT-JTOTI)),nint(JTOT+JTOTI)
         DO 1200 ISIG=0,1
          DO 1200 LTR=abs(JTR-ISIG),min(JTR+ISIG,ltransmax)
	if((-1)**LTR.ne.PARITY*PARITI) go to 1200
        	LSJ = LSJ+1

	if(FIRST) then
	  call chops(210+LSJ)
	  WRITE(210+LSJ,152) LTR,ISIG,JTR,JTOTI,PSIGN(PARITI+2),
     X			JTOT,PSIGN(PARITY+2)
152       FORMAT('# LSJ =',3I2,:,' for J=',f5.1,A1,' ->',f5.1,A1)
	  go to 1200
	endif
	  WRITE(159,153) EC,LTR,ISIG,JTR,NOP
153       FORMAT(1x,f10.5,3i2,i4,': MeV, LSJ, NOP')
       XAP=0.21954D0*SQRT(EC)
       XAPL =0.21954D0*SQRT(ABS(EGS))
       DEN=0.21954D0**2*0.5D0
       WFN = 1.D0/(2.D0*3.14159D0)
       WFNTR = 1.D0/sqrt(2.D0*3.14159D0*XAP**5)

	
      A111 = A1
      A222 = A2
      A333 = A3
C
C
      S1 = 0.5D0
      S2 = 0.5D0
       MJLI = 0
       MJ   = 0 
       MJHE = 0
C
c *** Print of B.S. WF
        do j = 1,numr,20
ccc        write(6,9345) (j-1)*step,(ful(mst,j),mst=1,3)
 9345   format(1x,f8.3,6g12.3)
        enddo
 
              XBD = sqrt(2d0*3.14159d0*XAP**5)
ccc	write(6,*) ' At K =',real(XAP),' XBD =',real(XBD)

C
C  *****  ANGULAR AND SPIN LOOPS ********
C  *****  Norm of core =1
      INOR  = 1
C  *****
C  *****  CORE CASE          ********
C
           ASUM =  A1 + A3 +A2
           ALF2 = (A1 + A2)/ASUM/A3
           ALF  = ALF2
           ALFSQ= DSQRT(ALF2)
c
           J  = JTR
           L  = LTR
C ___________________________________________________________________
c
       DO 511 J5= 1,NOP
 511    FUR(J5)= (0.e0,0.e0)

c  ***  Impuls loop - external Quantum numbers

          DO 9101 NSIMP=1,NOP
	     JFK=IOP(NSIMP)
	  if(KFAD(JFK).ne.1) go to 9101
C ___________________________________________________________________
c  ***   Initial state loop 
C
         DO 1101 NSL = 1,NSTGS
	  if(KFADGS(NSL).ne.1) go to 1101
C
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)

C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C
      CALL LOGFAC(1,2,1)
 401  FORMAT(10X,2I3,D15.5)
c __________________________________________________________________
C
C  **** LOOP ON FINAL (RADIAL) QUANT. NUMBERS ****
C
         DO 1102 NSH = 1,NSTHE
	  if(KFAD(NSH).ne.1) go to 1102
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
           L2HE = KSTHE(  NSH,5)
      IF((KLI.GT.ktransmax-2).AND.(KHE.GT.ktransmax-2))GOTO 1102
      IF((KLI.GT.ktransmax) .or. (KHE.GT.ktransmax)) GO TO 1102
C  *****
      JNOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
        IF(JNOR .EQ. 0) GO TO 1102
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
	endif
C  *****
C

        IF(L1HE .NE. L1LI)GO TO 791
      CALL ANGSPI2(S1,S2,L1HE,L2HE,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1LI,L2LI,LLI,ISLI,JLI,MJLI,AS)

       IF((L.EQ.0).AND.(ISIG.EQ.0)) AS = DABS(AS)
c       WRITE(4,4649) AS
 4649  FORMAT(1X,'=',G12.3/)

      IF(DABS(AS) .LT. 1.D-10) GO TO 791
C
C        ALF = DSQRT(ASUM/(A1 + A2))
C
C HYPERANGLE  INTEGRAL 

	UOUT = 0.d0

      DO 620 M=1,NIKZEN
      XX=M
      XX=XX/(NIKZEN+1.D0)
      XX=XX*3.14159265358D0
      XX=DCOS(XX)
      VXX=XX
      W=NIKZEN+1.D0
      W=3.14159265358D0/W*(1.D0-XX*XX)
      WEIHT=W
      X=(1.D0-VXX)/2.D0
        K1   =  KHE
         LV=  LHE
         L1  = L1HE
         L2  = L2HE
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ1,0)
 
       K1   =  KLI
         LV=  LLI
         L1  = L1LI
         L2  = L2LI
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ2,0)
c
      UOUT=UOUT+WEIHT*PJ1*PJ2/8.D0
 
620   CONTINUE



C RADIAL INTEGRAL .1 -  TO RMAX
       SU = (0.e0,0.e0)

      DO  IR=1,NX
         R12 = rrade(IR)
	 H  = wrade(IR)
	   TRFORM = 1d0
	   if(LTR.eq.0.and.ISIG.eq.0.and.JTR.eq.0) 
     x       TRFORM = 1d0/(1 + (R12/RHOSE)**3)
         IF(IR.GE.IMAGS)GO TO 310
          FULLL = FUL(NSL,IR)
            GO TO 311
 310      FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(NX*DR-R12))
 311    SU  = FUH(NSIMP,NSH,IR) * FULLL * H * TRFORM + SU
      ENDDO

	SU = SU*PHASE

ccc          WRITE(4,1120)KHE,LHE,L1HE1,L2HE2,UOUT,SU,K1,LV,L1,L2
ccc          WRITE(4,1120)KHE,LHE,L1HE1,L2HE2,
ccc     X                 AS,RRCHE(J1,I1),RRCLI(M1,N1),K1,LV,L1,L2
1120  FORMAT(' <HE:K,LL,L1,L2=',4I2,'|NORM=',3G11.3,'|LI: ',4I2,'>')

      SU = SU*UOUT 

       FUR(NSIMP) = FUR(NSIMP) + 
     *       SU*AS * INOR

791   CONTINUE
891   CONTINUE

c *** End of continuum   (fin) loop

1102  CONTINUE

c *** End of bound state (ini) loop
1101  CONTINUE

c *** End of impuls loop
9101  CONTINUE

c     WRITE(4,1518) JHE,MJHE,L,ISIG,J,MJ,JLI,MJLI
1518  FORMAT(1X,'<JF,MJF=',2I3,'|L, S ,J,MJ=',4I3,'|JI,MJI=',2I3,'>'/)
      AC= (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0)
       AC= WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * AC
c     WRITE(4,1918) JLI,MJLI,J,MJ,JHE,MJHE,AC
1918  FORMAT(1X,'<JL,MJL=',2I3,'J,MJ=',2I3,'|JH,MJH=',2I3,'>=',F5.3/)

	   UOUT = 0.d0

         DO  KLS = 1,NOP
          SH(KLS) = cabs(FUR(KLS))**2 * DEN*WFN/XAP
	    UOUT = UOUT + SH(KLS)

	  enddo
c
c *** Printout  of strength functions for given lsj trans:

         WRITE(210+LSJ,9515) ec,UOUT,(SH(KLS),KLS = 1,min(NOP,6))
         dSdE = dSdE + UOUT
         WRITE(159,1920) (FUR(KLS)*WFNTR,KLS = 1,NOP)
1920         FORMAT(1p,6e12.4)
1200	continue

c *** End of lsj transition loop

	if(FIRST) return
c
c *** Printout of SUM of strength functions:

       WRITE(210,9515) ec,dSdE
c       WRITE(210,9515) ec,dSdE*(2*JTOT+1)
C
 9515 FORMAT(3X,f8.3, g14.4, 3x,6G12.3) 
ccc        write(4,*) 'SF factor at EC',real(EC),' =',DEN*WFN/XAP
      RETURN
1111   WRITE(4,1112)
1112   FORMAT(1X,' !!!!  ERROR : MJLI + MJ .NE. MJHE  !!!!!'/)
      RETURN
9902   WRITE(4,9912)
       WRITE(6,9912)
9912   FORMAT(1X,' !!!!  ERROR :  SLI + SHE + TLI+THE ODD !'/)
      RETURN
      END
