      SUBROUTINE CONDEN(FUL,EC,KSTHE,NSTHE,IOP,NOP,FUH,LSJ,NEMAX,ibscon)
C    ***********************************************************
C
C        CALCULATION OF TRANSITION DENSITIES TO 3-B CONTINUUM                       
C    ********* CREATION DATE  11-3-95 CHANGES: 17 Nov 1995 (IJT)
C
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAYs KSTGS,KSTHE
C
c ------------ LI - bound     (initial) State
c ------------ HE - quasibound(ibscon=0) or continuum (final) ( =1) State
c
C        TRANSITION DENSITIES TO 3-B CONTINUUM  ARE in  TRD(*)
C        STRENGTH FUNCTIONS   TO 3-B CONTINUUM  ARE in  FUR

	use parameters
	use globals
	use gs
	use scattering
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      LOGICAL FIRST

      COMPLEX*8 SU,TRD(mtrans),FUDN(MNOP,mtrans),FUDA(MNOP,mtrans),FUR
C
      DIMENSION KSTHE(MCHAN3,LXTRA+1)
      COMPLEX*16 FUH(MNOP,MCHAN3,NMAXF),SUU(MCHAN3),SUUp
      DIMENSION FUL(nstgs,NMAXF),IOP(NOP)
      INTEGER PHASE

C *******************************************************************
c ---------  Reynal-Revai Coefficients
C
      COMMON/ROT/C,S,T,A(99,29),JO11,JO12
      COMMON/MASES/A111,A222,A333

       DIMENSION SH(MCHAN3),RRCLI(30,30),RRCHE(30,30)
     * ,L1LIM(30,30),L2LIM(30,30),L1HEM(30,30),L2HEM(30,30)

C########################################################### for STURMR:
      NX = numrs
      DR = steps
	if(glag) NX = numr
      IMAGS = numr

C    *** initial Step of CORE tr. den. radial points: further HTRANS*(A1+A2)/A3
	HTRANSc = 0.1

      NTRANS=min(nint(RTRANS/HTRANS),mtrans)
c	write(6,*) 'CONDEN: EC,LSJ,NTRANS =',real(EC),LSJ,NTRANS
!				Get information from globals for local use:
!				Assumes 1,2 are nucleons, 3 is core!
	A1 = mass(1)
	A2 = mass(2)
	A3 = mass(3)

	HTRANSc = HTRANS/int(A3/(A1+A2))
C    *** Number of hyperangle points:
C
      NIKZEN=20

C    *** Max number of asymptotic channels (see format 1520!):
C
  
      MXXNOP=20

	    NXXTR = 0

	DO ICON = 1,NSTHE
	 KCON = KSTHE(ICON,1)
	  IF(KCON .LE. ktransmax)NXXTR = NXXTR + 1
	ENDDO

	if(ibscon.ne.0)then
      NXX1 = min(NOP,MXXNOP)
      NXX = min(NXX1,NXXTR)
	else
	  NXX = NXXTR
	endif

cbd  *** test
c	write(6,*)'#NSTHE,NOP,NXX1,NXXTR,NXX',NSTHE,NOP,NXX1,NXXTR,NXX
c	write(6,*)'#LSJ',LSJ

	JLI = nint(JTOTI)
	IPLI= PARITI
	ITLI = TTGS

	JHE  = nint(JTOT)
	IPHE = PARITY
	ITHE = TT
	  WRITE(6,152) JHE,IPHE,ITHE,LTR,ISIG,JTR,
     X		JLI,IPLI,ITLI	
cbd------------------------------------------------------------------
cbd  *******  Orthogonalization of GS and same continuum  ********
cbd
	if(JLI.eq.JHE .and. IPLI.eq.IPHE .and. ITLI.eq.ITHE
     X      .and. ibscon.ne.0) then
cpw         go to 6666	
c
c  ***  Impuls loop - external Quantum numbers

	   NXXI = NXX
	   if(ibscon.eq.0) NXXI = 1

          DO  NSIMP=1,NXXI

		SUU(NSIMP) = (0.d0,0.d0)

	  enddo
           DO  NSIMP=1,NXXI

		SUUP = (0.d0,0.d0)

            DO  Nbs=1,NXXI

             DO  I=1,NX

              SUUP = SUUP + FUH(NSIMP,NBS,I)*FUL(Nbs,I) * H

	     enddo

	    enddo

		SUU(NSIMP) = SUU(NSIMP) + SUUP

	   enddo

           DO  NSIMP=1,NXXI

            DO  Nbs=1,NXXI

             DO  I=1,NX

              FUH(NSIMP,NBS,I) = FUH(NSIMP,NBS,I) -SUU(NSIMP)*FUL(Nbs,I) 

	     enddo

	    enddo

	   enddo



	endif
cbd------------------------------------------------------------------
cbd  ******* END of  Orthogonalization of GS and same continuum  ********
cbd
cpw 6666   continue


	FIRST = LSJ.eq.0
		LSJ = 0
	DO 1200 JTR=nint(abs(JTOT-JTOTI)),nint(JTOT+JTOTI)
	DO 1200 ISIG=0,1
	DO 1200 LTR=abs(JTR-ISIG),JTR+ISIG
	if((-1)**LTR.ne.PARITY*PARITI) go to 1200
	LSJ = LSJ+1

cbd  *** test
c	write(6,*)'FIRST',FIRST
	write(4,*)'FIRST',FIRST,lsj
c	  WRITE(6,152) JHE,IPHE,ITHE,LTR,ISIG,JTR,
c     X		JLI,IPLI,ITLI	
	  WRITE(4,152) JHE,IPHE,ITHE,LTR,ISIG,JTR,
     X		JLI,IPLI,ITLI	

	if(FIRST) then
c
c ***************  N-N   CASE
c
	  call chops(180+LSJ)
	if(ibscon.eq.0)WRITE(180+LSJ,*)' **** QUASIBOUND FINAL STATE **'
	if(ibscon.ne.0)WRITE(180+LSJ,*)' **** CONTINUUM  FINAL STATE **'


	  WRITE(180+LSJ,152) JHE,IPHE,ITHE,LTR,ISIG,JTR,
     X		JLI,IPLI,ITLI	
152     FORMAT('# NN Transition densities <Jf pf Tf /L S J/ Ji pi Ti>'/
     X     ,26X,9I3)
	  WRITE(180+LSJ,156) NTRANS,HTRANS,NXX,NEMAX
156     FORMAT('# NTRANS,HTRANS,NSTMAX,NEMAX'/
     X     ,2X,I6,F6.2,2I6)
	  WRITE(180+LSJ,*) '# Quantum numbers of selected final states:'
          WRITE(180+LSJ,*)'  Num K   L   S   lx  ly'
	 
	    DO icon = 1,NXX
	  WRITE(180+LSJ,157) icon,(KSTHE(ICON,JCON),JCON=1,5)
	    ENDDO
157     FORMAT(6I4)


	 if(LSJ.le.9.and.ibscon.ne.0)  then
           call chops(170+LSJ)
      	  WRITE(170+LSJ,153) LTR,ISIG,JTR,JTOTI,PSIGN(PARITI+2),
     X			JTOT,PSIGN(PARITY+2)
153       FORMAT('# NN Integrated transition densities LSJ =',3I2,
     X     ' for J=',f5.1,A1,' ->',f5.1,A1)
	  endif
c
c ***************  CORE CASE
c
	  call chops(200+LSJ)
	if(ibscon.eq.0)WRITE(200+LSJ,*)' **** QUASIBOUND FINAL STATE **'
	if(ibscon.ne.0)WRITE(200+LSJ,*)' **** CONTINUUM  FINAL STATE **'

	  WRITE(200+LSJ,2152) JHE,IPHE,ITHE,LTR,ISIG,JTR,
     X		JLI,IPLI,ITLI	
2152    FORMAT('# Core Transit. densities <Jf pf Tf /L S J/ Ji pi Ti>'/
     X     ,26X,9I3)
	  WRITE(200+LSJ,156) NTRANS,HTRANSc,NXX,NEMAX

	  WRITE(200+LSJ,*) '# Quantum numbers of selected final states:'
          WRITE(200+LSJ,*)'  Num K   L   S   lx  ly'
	 
	    DO icon = 1,NXX
	  WRITE(200+LSJ,157) icon,(KSTHE(ICON,JCON),JCON=1,5)
	    ENDDO

cbd	  WRITE(200+LSJ,2152) LTR,ISIG,JTR,JTOTI,PSIGN(PARITI+2),
cbd     X			JTOT,PSIGN(PARITY+2)
cbd2152       FORMAT('# Transition densities LSJ =',3I2,
cbd     X     ' for J=',f5.1,A1,' ->',f5.1,A1)
	 if(LSJ.le.9.and.ibscon.ne.0)  then
           call chops(190+LSJ)
      	  WRITE(190+LSJ,2153) LTR,ISIG,JTR,JTOTI,PSIGN(PARITI+2),
     X			JTOT,PSIGN(PARITY+2)
2153       FORMAT('# Integrated transition densities LSJ =',3I2,
     X     ' for J=',f5.1,A1,' ->',f5.1,A1)
	  endif
	  go to 1200
	endif
       XAP=0.21954D0*SQRT(EC)
       XAPL =0.21954D0*SQRT(ABS(EGS))
       DEN=0.21954D0**2*0.5D0
       WFN = 1.D0/(2.D0*3.14159D0)
       WFNTR = 1.D0/sqrt(2.D0*3.14159D0*XAP**5)
         WRITE(180+LSJ,154) EC,NXX,NTRANS,HTRANS
         WRITE(200+LSJ,154) EC,NXX,NTRANS,HTRANSc
154   	 FORMAT('#',F8.3,' MeV,',I4,' open channels,',I4,' steps of',
     X		F8.3,' fm')
	
      A111 = A1
      A222 = A2
      A333 = A3
C
C
      S1 = 0.5D0
      S2 = 0.5D0
       MJLI = 0
       MJ   = 0 
       MJHE = 0
C
C  *****  ANGULAR AND SPIN LOOPS ********
C  *****
      INOR  = 2
C     INOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
C       IF(INOR .EQ. 0) GO TO 9902
C  *****
C  *****  NUCLEONS CASE          ********
C
           ASUM =  A1 + A3 +A2
           ALF2 = (A1 + A3)/ASUM/A2
           ALF3 = (A1 + A2)/ASUM/A3
cbd           ALF  = ALF2
cbd           ALFSQ= DSQRT(ALF2)
C          IF(ALF1 .LT. ALF2) ALF = ALF1
c
           J  = JTR
           L  = LTR
C ___________________________________________________________________
c
c  ***  Impuls loop - external Quantum numbers

	   NXXI = NXX
	   if(ibscon.eq.0) NXXI = 1

          DO 9101 NSIMP=1,NXXI
	     JFK=IOP(NSIMP)
	  if(KFAD(JFK).ne.1) go to 9101
c         WRITE(180+LSJ,512) NSIMP
c512   	  FORMAT('#',I3,' = asymptotic channel')
c
c *****   Clearing densities
c
             DO  I = 1,NTRANS
               FUDN(NSIMP,I) = (0.,0.)
               FUDA(NSIMP,I) = (0.,0.)
             enddo  
C ___________________________________________________________________
c  ***   Initial state loop 
C
         DO 1101 NSL = 1,NSTGS
	  if(KFADGS(NSL).ne.1) go to 1101
C
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)

C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C
      CALL LOGFAC(1,2,1)
      CALL LOGFAC(NPEAR1,NPEAR2,0)
      CALL RRCOE(KLI,LLI,L1LI,L2LI)
        K    =  KLI
         N=  LLI
         L1  = L1LI
         L2  = L2LI
         NNKL= KLI - LLI
      NN=NNKL-2*(NNKL/2)

      JL11   =  JO11
      JL12   =  JO12
      DO 91   M1=1,JO11
      DO 91   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
       L1LIM (M1,N1) =   L1
       L2LIM (M1,N1) =   L2
        RRCLI(M1,N1) = A(M1,N1)
C
 401  FORMAT(10X,2I3,D15.5)
 91   CONTINUE
C     KLI = KSTGS(6,NSL)
c
c __________________________________________________________________
C
C  **** LOOP ON FINAL (RADIAL) QUANT. NUMBERS ****
C
         DO 1102 NSH = 1,NXX
	  if(KFAD(NSH).ne.1) go to 1102
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
           L2HE = KSTHE(  NSH,5)
cbd      IF((KLI.GT.ktransmax-2).AND.(KHE.GT.ktransmax-2))GOTO 1102
cbd      IF((KLI.GT.ktransmax) .or. (KHE.GT.ktransmax)) GO TO 1102
c      IF(L1HE.NE.2)  GO TO 1102
c          WRITE(180+LSJ,*)' L1HE.Eq.2 '
      IF(KLI.GT.ktransmax) GO TO 1102
c      IF(LHE.ne.0 .and. ISHE.ne.1) GO TO 1102
C  *****
      JNOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
        IF(JNOR .EQ. 0) GO TO 1102
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
	endif
C  *****
c       WRITE(4,*) '*******  NN initial ****LSJ ',LSJ,LTR,ISIG,JTR
c       WRITE(4,4647) L1LI,L2LI,LLI,ISLI,JLI,MJLI
c       WRITE(4,4646) L1HE,L2HE,LHE,ISHE,JHE,MJHE
C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C
      CALL LOGFAC(1,2,1)
      CALL LOGFAC(NPEAR1,NPEAR2,0)
      CALL RRCOE(KHE,LHE,L1HE,L2HE)
        K    =  KHE
         N=  LHE
         L1  = L1HE
         L2  = L2HE
         NNKL= KHE - LHE
      NN=NNKL-2*(NNKL/2)

      JH11   =  JO11
      JH12   =  JO12

      DO991   M1=1,JO11
      DO991   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
        RRCHE(M1,N1) = A(M1,N1)
       L1HEM (M1,N1) =   L1
       L2HEM (M1,N1) =   L2
C
c      WRITE (7,401) L1,L2,A(M1,N1)
c      WRITE (6,401) L1,L2,A(M1,N1)
C401  FORMAT(10X,2I3,D15.5)
991   CONTINUE
 112  CONTINUE

C     JH11   =  JO11
C     JH12   =  JO12
         NNKLL= KLI - LLI
      NNLI=NNKLL-2*(NNKLL/2)
      DO891   M1=1,JL11
      DO891   N1=1,JL12
      L1LI1=  L1LIM(M1,N1)
      L2LI2=  L2LIM(M1,N1)
C     L1LI1=(KLI-(LLI-NNLI))/2+N1-M1
C     L2LI2=(KLI+(LLI-NNLI))/2-N1-M1+2
C       RRCHE(M1,N1) = A(M1,N1)
         NNKLH= KHE - LHE
      NNHE=NNKLH-2*(NNKLH/2)
      DO791   J1=1,JH11
      DO791   I1=1,JH12
      L1HE1=  L1HEM(J1,I1)
      L2HE2=  L2HEM(J1,I1)
C     L1HE1=(KHE-(LHE-NNHE))/2+J1-I1
C     L2HE2=(KHE+(LHE-NNHE))/2-J1-I1+2
C     WRITE(4,8642)KLI,LLI,ISLI,L1LI1
c       WRITE(4,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(4,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
c       WRITE(7,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(7,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE

C       RRCHE(J1,I1) = A(M1,N1)
C
        IF(L1HE1 .NE. L1LI1)GO TO 791
      CALL ANGSPI2(S1,S2,L1HE1,L2HE2,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI,AS)
c       WRITE(4,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
 4646  FORMAT(1X,'<  L1HE1,L2HE2,LHE,ISHE,JHE,MJHE =',6I3,' |')
c       WRITE(4,4648) L,ISIG,J  ,MJ
 4648  FORMAT(1X,'|  L  ,ISIG,J  ,MJ   =',4I3,' |')
c       WRITE(4,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
 4647  FORMAT(1X,'|  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI =',6I3,' >')
       IF((L.EQ.0).AND.(ISIG.EQ.0)) AS = DABS(AS)
c       WRITE(4,4649) AS
 4649  FORMAT(1X,'=',G12.3/)

      IF(DABS(AS) .LT. 1.D-10) GO TO 791
C
       DO 305 J5= 1,NTRANS
 305    TRD(J5)= 0d0
          ANOR = 0d0
C
           ALF  = ALF2
           ALFSQ= DSQRT(ALF2)
C HYPERANGLE  INTEGRAL 
        DO 501 JR = 1, NTRANS
        R =  HTRANS*JR
        Y = R/ALFSQ
        Y2= Y**2

C RADIAL INTEGRAL 
       SU = 0d0
      DO 5 I=1,NX
         RO = rrade(I)
	  if(RO.lt.Y) go to 5
	  if(RO.gt.HTRANS*NTRANS*1.1) go to 5
	 H  = wrade(I)
        RO2= RO**2
        XX = RO2 - Y2
        IF ( XX .LT. 0.D0) XX = 0.D0
      X = XX/RO2
      X2 = DSQRT(XX)

        K1   =  KHE
         LV=  LHE
         L1  = L1HE1
         L2  = L2HE2
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ1,0)
 
       K1   =  KLI
         LV=  LLI
         L1  = L1LI1
         L2  = L2LI2
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ2,0)
c
         IF(I.GE.IMAGS)GO TO 310
          FULLL = FUL(NSL,I)
            GO TO 311
 310      FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(NX*DR-RO))

 311     SU = SU + FUH(NSIMP,NSH,I)*FULLL*PJ1*PJ2*X2/RO2/RO2 * H

c      WRITE(160,1519) RX ,FUH(NSIMP,NSH,I),FULLL,PJ1,PJ2,T2
1519  FORMAT(F9.3,1X,8G12.4)
 5    CONTINUE
	SU = SU*PHASE
       TRD(JR) = SU /ALF / ALFSQ
        ANOR = ANOR + TRD(JR)*R**2
 501  CONTINUE
        ANORnn = ANOR * HTRANS*AS*RRCHE(J1,I1)*RRCLI(M1,N1)*INOR

       DO  JR = 1,NTRANS
       FUDN(NSIMP,JR) = FUDN(NSIMP,JR) + 
     X		  TRD(JR)*AS*RRCHE(J1,I1)*RRCLI(M1,N1)*INOR
c       RX = HTRANS*JR
c       WRITE(6,1519) RX,TRD(JR),FUDN(NSIMP,JR)
	enddo

791   CONTINUE
891   CONTINUE

c *** End of continuum   (fin) loop

1102  CONTINUE

c *** End of bound state (ini) loop
1101  CONTINUE


c#####################################################################################################
c
c     =========   Core case
c
	  if(ISIG.ne.0) go to 9111

c  ***   Initial state loop 
C
         DO 2101 NSL = 1,NSTGS
	  if(KFADGS(NSL).ne.1) go to 2101
C
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)

      IF(LLI.ne.0 .and. ISLI.ne.1) GO TO 2101
C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C

c __________________________________________________________________
C
C  **** LOOP ON FINAL (RADIAL) QUANT. NUMBERS ****
C
         DO 2102 NSH = 1,NXX
	  if(KFAD(NSH).ne.1) go to 2102
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
      IF(L1LI. NE .L1HE)GOTO 2102
           L2HE = KSTHE(  NSH,5)
cbd      IF((KLI.GT.ktransmax-2).AND.(KHE.GT.ktransmax-2))GOTO 2102
cbd      IF((KLI.GT.ktransmax) .or. (KHE.GT.ktransmax)) GO TO 2102
c      IF(L2HE.NE.0)  GO TO 2102
c          WRITE(200+LSJ,*)' L2HE.Eq.0 '
      IF(KLI.GT.ktransmax) GO TO 2102
c      IF(LHE.ne.0 .and. ISHE.ne.1) GO TO 2102
C  *****
c      JNOR  = INT(A3)
c *** supposed mass of point core = 1
      JNOR  = 1
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
	endif
C  *****

      CALL ANGSPI2(S1,S2,L1HE,L2HE,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1LI,L2LI,LLI,ISLI,JLI,MJLI,AS)

      IF(DABS(AS) .LT. 1.D-10) GO TO 2102
C
cbd	HTRANSc = 0.1 in begining: scaled HTRANSc=HTRANS(A1+A2)/A3 - end
       DO  J5= 1,NTRANS
        TRD(J5)= (0.,0.)
	ENDDO
          ANOR = 0d0
C
           ALF  = ALF3
           ALFSQ= DSQRT(ALF)
C HYPERANGLE  INTEGRAL 
        DO 2501 JR = 1, NTRANS
        R =  HTRANSc*JR
        Y = R/ALFSQ
        Y2= Y**2
c	write(160,*) ' JR,R,Y,NX =',JR,real(R),real(Y),NX

C RADIAL INTEGRAL 
       SU = 0d0
      DO 25 I=1,NX
         RO = rrade(I)
	  if(RO.lt.Y) go to 25
	  if(RO*ALFSQ.gt.HTRANSc*NTRANS*1.1) go to 25
	 H  = wrade(I)
        RO2= RO**2
        XX = RO2 - Y2
        IF ( XX .LT. 0.D0) XX = 0.D0
      X = XX/RO2
      X2 = DSQRT(XX)

        K1   =  KHE
         LV=  LHE
         L1  = L1HE
         L2  = L2HE
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ1,0)
 
       K1   =  KLI
         LV=  LLI
         L1  = L1LI
         L2  = L2LI
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ2,0)
c
         IF(I.GE.IMAGS)GO TO 2310
          FULLL = FUL(NSL,I)
            GO TO 2311
 2310      FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(NX*DR-RO))

 2311     SU = SU + FUH(NSIMP,NSH,I)*FULLL*PJ1*PJ2*X2/RO2/RO2 * H

c      WRITE(160,1517) RO ,FUH(NSIMP,NSH,I),FULLL,PJ1,PJ2,SU
c1517  FORMAT(F9.3,1X,9G12.4)
 25    CONTINUE
	SU = SU*PHASE
       TRD(JR) = SU /ALF / ALFSQ
        ANOR = ANOR + TRD(JR)*R**2
 2501  CONTINUE
        ANORc = ANOR * HTRANSc * AS

       DO  JR = 1,NTRANS
       FUDA(NSIMP,JR) = FUDA(NSIMP,JR) + 
     X		  TRD(JR)*AS* JNOR
c       RX = HTRANSc*JR
c       WRITE(6,1519) RX,TRD(JR),FUDN(NSIMP,JR)
	enddo

c791   CONTINUE
c891   CONTINUE

c *** End of continuum   (fin) loop

2102  CONTINUE

c *** End of bound state (ini) loop
2101  CONTINUE


9111  CONTINUE
c#####################################################################################################


c        DO  JR = 1,NTRANS
c       	RX = HTRANS*JR
c       	WRITE(180+LSJ,1519) RX ,FUDN(NSIMP,JR)
c	enddo
c      	WRITE(180+LSJ,*) '&'

c *** End of impuls loop
9101  CONTINUE

c     WRITE(4,1518) JHE,MJHE,L,ISIG,J,MJ,JLI,MJLI
1518  FORMAT(1X,'<JF,MJF=',2I3,'|L, S ,J,MJ=',4I3,'|JI,MJI=',2I3,'>'/)
      AC= (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0)
       AC= WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * AC
c     WRITE(4,1918) JLI,MJLI,J,MJ,JHE,MJHE,AC
1918  FORMAT(1X,'<JL,MJL=',2I3,'J,MJ=',2I3,'|JH,MJH=',2I3,'>=',F5.3/)
c
c   *************  PRINTING OUT OF #NN# DENS and STRFN
c
	 if(ibscon.eq.0)WFNTR = 1.d0 

          ANOR = 0d0

        DO  JR = 1,NTRANS
       	RX = HTRANS*JR
        ANOR = ANOR + FUDN(1,JR)*RX**2
       	WRITE(180+LSJ,1520) RX ,(FUDN(NSIMP,JR)*WFNTR,NSIMP=1,NXXI)
1520  	FORMAT(F9.3,1X,1p,20E11.3,:,(/10x,20E11.3))
	enddo
	ANORnn = ANOR*HTRANS
        WRITE(6,9515) ec,WFNTR,ANORnn,ANORnn*WFNTR
      	WRITE(180+LSJ,*) '&'
	if(ibscon.eq.0)WRITE(180+LSJ,*) ' *** Norm of NN dens=',ANORnn
	 UOUT = 0.d0

	if(ibscon.ne.0)then
         DO  KLS = 1,NXX
	   	FUR=(0.,0.)
  	      DO  JR = 1,NTRANS
   	    	RX = HTRANS*JR
       		FUR = FUR + FUDN(KLS,JR)*RX*RX
		enddo
		FUR = FUR * HTRANS
           SH(KLS) = cabs(FUR)**2 * DEN*WFN/XAP
	    UOUT = UOUT + SH(KLS)
	  enddo
	if(LSJ.le.9) 
     X  WRITE(170+LSJ,9515) ec,UOUT,(SH(KLS),KLS = 1,min(NOP,6,MXXNOP))
 9515 	 FORMAT(3X,f8.3, g14.4, 3x,6G12.3) 
	endif
c
c   *************  PRINTING OUT OF core DENS and STRFN
c
	  if(ISIG.ne.0) go to 9121

          ANOR = 0d0

        DO  JR = 1,NTRANS
       	RX = HTRANSc*JR
        ANOR = ANOR + FUDA(1,JR)*RX**2

       	WRITE(200+LSJ,1520) RX ,(FUDA(NSIMP,JR)*WFNTR,NSIMP=1,NXXI)
c1520  	FORMAT(F9.3,1X,1p,20E11.3,:,(/10x,20E11.3))
	enddo

	ANORc = ANOR*HTRANSc
      	WRITE(200+LSJ,*) '&'
	if(ibscon.eq.0)WRITE(200+LSJ,*) ' *** Norm of Core dens=',ANORc

	 UOUT = 0.d0
	if(ibscon.ne.0)then

         DO  KLS = 1,NXX
	   	FUR=(0.,0.)
  	      DO  JR = 1,NTRANS
   	    	RX = HTRANSc*JR
       		FUR = FUR + FUDA(KLS,JR)*RX*RX
		enddo
		FUR = FUR * HTRANSc
           SH(KLS) = cabs(FUR)**2 * DEN*WFN/XAP
	    UOUT = UOUT + SH(KLS)
	  enddo
	if(LSJ.le.9) 
     X  WRITE(190+LSJ,9515) ec,UOUT,(SH(KLS),KLS = 1,min(NOP,6,MXXNOP))
	endif
C
9121   continue
c   *******************

1200	continue
      RETURN
c   *******************

9902   WRITE(4,9912)
       WRITE(6,9912)
9912   FORMAT(1X,' !!!!  ERROR :  SLI + SHE + TLI+THE ODD !'/)
      RETURN
      END
