      SUBROUTINE CONSF(FUL,EC,KSTHE,NSTHE,IOP,NOP,FUH,LTR,ISIG,JTR)
C    ***********************************************************
C
C        CALCULATION OF STRENGTH FUNCTION TO 3-B CONTINUUM                       
C    ********* CREATION DATE  11-3-95 CHANGES: 17 Nov 1995 (IJT)
C
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAYs KSTGS,KSTHE
C
c ------------ LI - bound     (initial) State
c ------------ HE - continuum (final)   State
c
C        STRENGTH FUNCTION TO 3-B CONTINUUM  ARE in  FUR(*)
	use parameters
	use globals
	use gs
	use scattering
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      COMPLEX*8 SU,FUR(MCHAN3)
C
      DIMENSION KSTHE(MCHAN3,7)
      COMPLEX*16 FUH(MNOP,MCHAN3,NMAXF)
      DIMENSION FUL(nstgs,NMAXF),IOP(NOP)
      INTEGER PHASE

C *******************************************************************
c ---------  Reynal-Revai Coefficients
C
      COMMON/ROT/C,S,T,A(99,29),JO11,JO12
      COMMON/MASES/A111,A222,A333

       DIMENSION SH(MCHAN3),RRCLI(30,30),RRCHE(30,30)
     * ,L1LIM(30,30),L2LIM(30,30),L1HEM(30,30),L2HEM(30,30)

C########################################################### for STURMR:
      NX = numrs
      DR = steps
	if(glag) NX = numr
      IMAGS = numr

!				Get information from globals for local use:
!				assumes 1,2 are nucleons, 3 is core!
	A1 = mass(1)
	A2 = mass(2)
	A3 = mass(3)
C    *** Number of hyperangle points
C
      NIKZEN=20

	JLI = JTOTI
	IPLI= PARITI
	ITLI = TTGS
	JHE  = JTOT
	IPHE = PARITY
	ITHE = TT

       XAP=0.21954D0*SQRT(EC)
       XAPL =0.21954D0*SQRT(ABS(EGS))
       DEN=0.21954D0**2*0.5D0
       WFN = 1.D0/(2.D0*3.14159D0)
	
      A111 = A1
      A222 = A2
      A333 = A3
C
C
      S1 = 0.5D0
      S2 = 0.5D0
       MJLI = 0
       MJ   = 0 
       MJHE = 0
C
c *** Print of B.S. WF
        do j = 1,numr,20
ccc        write(6,9345) (j-1)*step,(ful(mst,j),mst=1,3)
 9345   format(1x,f8.3,6g12.3)
        enddo
 
              XBD = sqrt(2d0*3.14159d0*XAP**5)
ccc	write(6,*) ' At K =',real(XAP),' XBD =',real(XBD)
c *** Print of contin WF
        do j = 1,NX,5
ccc        write(6,9345) (j-1)*DR,(fuh(mst,mst,j)/XBD,mst=1,3)
C        write(6,9345) (j-1)*DR,(fuh(mst,mst,j),mst=1,3)
        enddo

C
C  *****  ANGULAR AND SPIN LOOPS ********
C  *****
      INOR  = 2
C     INOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
C       IF(INOR .EQ. 0) GO TO 9902
C  *****
C  *****  NUCLEONS CASE          ********
C
           ASUM =  A1 + A3 +A2
           ALF2 = (A1 + A3)/ASUM/A2
           ALF3 = (A1 + A2)/ASUM/A3
           ALF  = ALF2
           ALFSQ= DSQRT(ALF2)
C          IF(ALF1 .LT. ALF2) ALF = ALF1
c
           J  = JTR
           L  = LTR
C ___________________________________________________________________
c
       DO 511 J5= 1,NOP
 511    FUR(J5)= (0.e0,0.e0)

c  ***  Impuls loop - external Quantum numbers

          DO 9101 NSIMP=1,NOP
	     JFK=IOP(NSIMP)
	  if(KFAD(JFK).ne.1) go to 9101
C ___________________________________________________________________
c  ***   Initial state loop 
C
         DO 1101 NSL = 1,NSTGS
	  if(KFADGS(NSL).ne.1) go to 1101
C
      KLI = KSTGS(  NSL,1)
       LLI = KSTGS(  NSL,2)
        ISLI = KSTGS(  NSL,3)
         L1LI = KSTGS(  NSL,4)
           L2LI = KSTGS(  NSL,5)

C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C
      CALL LOGFAC(1,2,1)
      CALL LOGFAC(NPEAR1,NPEAR2,0)
      CALL RRCOE(KLI,LLI,L1LI,L2LI)
        K    =  KLI
         N=  LLI
         L1  = L1LI
         L2  = L2LI
         NNKL= KLI - LLI
      NN=NNKL-2*(NNKL/2)

      JL11   =  JO11
      JL12   =  JO12
      DO 91   M1=1,JO11
      DO 91   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
       L1LIM (M1,N1) =   L1
       L2LIM (M1,N1) =   L2
        RRCLI(M1,N1) = A(M1,N1)
C
 401  FORMAT(10X,2I3,D15.5)
 91   CONTINUE
C     KLI = KSTGS(6,NSL)
c
c __________________________________________________________________
C
C  **** LOOP ON FINAL (RADIAL) QUANT. NUMBERS ****
C
         DO 1102 NSH = 1,NSTHE
	  if(KFAD(NSH).ne.1) go to 1102
C
      KHE = KSTHE(  NSH,1)
       LHE = KSTHE(  NSH,2)
        ISHE = KSTHE(  NSH,3)
         L1HE = KSTHE(  NSH,4)
           L2HE = KSTHE(  NSH,5)
      IF((KLI.GT.ktransmax-2).AND.(KHE.GT.ktransmax-2))GOTO 1102
      IF((KLI.GT.ktransmax) .or. (KHE.GT.ktransmax)) GO TO 1102
C  *****
      JNOR  = 1 + (-1)**(ISLI+ISHE+     ITHE+ITLI)
        IF(JNOR .EQ. 0) GO TO 1102
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
	endif
C  *****
C
C NPEAR: 1= M1-(M2-M3); 2= M2-(M1-M3); 3=M3-(M1-M2)
C
        NPEAR1  =   3
        NPEAR2  =   1
C
      CALL LOGFAC(1,2,1)
      CALL LOGFAC(NPEAR1,NPEAR2,0)
      CALL RRCOE(KHE,LHE,L1HE,L2HE)
        K    =  KHE
         N=  LHE
         L1  = L1HE
         L2  = L2HE
         NNKL= KHE - LHE
      NN=NNKL-2*(NNKL/2)

      JH11   =  JO11
      JH12   =  JO12

      DO991   M1=1,JO11
      DO991   N1=1,JO12
      L1=(K-(N-NN))/2+N1-M1
      L2=(K+(N-NN))/2-N1-M1+2
        RRCHE(M1,N1) = A(M1,N1)
       L1HEM (M1,N1) =   L1
       L2HEM (M1,N1) =   L2
C
c      WRITE (7,401) L1,L2,A(M1,N1)
c      WRITE (6,401) L1,L2,A(M1,N1)
C401  FORMAT(10X,2I3,D15.5)
991   CONTINUE
 112  CONTINUE

C     JH11   =  JO11
C     JH12   =  JO12
         NNKLL= KLI - LLI
      NNLI=NNKLL-2*(NNKLL/2)
      DO891   M1=1,JL11
      DO891   N1=1,JL12
      L1LI1=  L1LIM(M1,N1)
      L2LI2=  L2LIM(M1,N1)
C     L1LI1=(KLI-(LLI-NNLI))/2+N1-M1
C     L2LI2=(KLI+(LLI-NNLI))/2-N1-M1+2
C       RRCHE(M1,N1) = A(M1,N1)
         NNKLH= KHE - LHE
      NNHE=NNKLH-2*(NNKLH/2)
      DO791   J1=1,JH11
      DO791   I1=1,JH12
      L1HE1=  L1HEM(J1,I1)
      L2HE2=  L2HEM(J1,I1)
C     L1HE1=(KHE-(LHE-NNHE))/2+J1-I1
C     L2HE2=(KHE+(LHE-NNHE))/2-J1-I1+2
C     WRITE(4,8642)KLI,LLI,ISLI,L1LI1
c       WRITE(4,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(4,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
c       WRITE(7,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
c       WRITE(7,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE

C       RRCHE(J1,I1) = A(M1,N1)
C
        IF(L1HE1 .NE. L1LI1)GO TO 791
      CALL ANGSPI2(S1,S2,L1HE1,L2HE2,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI,AS)
c       WRITE(4,4646) L1HE1,L2HE2,LHE,ISHE,JHE,MJHE
 4646  FORMAT(1X,'<  L1HE1,L2HE2,LHE,ISHE,JHE,MJHE =',6I3,' |')
c       WRITE(4,4648) L,ISIG,J  ,MJ
 4648  FORMAT(1X,'|  L  ,ISIG,J  ,MJ   =',4I3,' |')
c       WRITE(4,4647) L1LI1,L2LI2,LLI,ISLI,JLI,MJLI
 4647  FORMAT(1X,'|  L1LI1,L2LI2,LLI,ISLI,JLI,MJLI =',6I3,' >')
       IF((L.EQ.0).AND.(ISIG.EQ.0)) AS = DABS(AS)
c       WRITE(4,4649) AS
 4649  FORMAT(1X,'=',G12.3/)

      IF(DABS(AS) .LT. 1.D-10) GO TO 791
C
C        ALF = DSQRT(ASUM/(A1 + A3))
C
C HYPERANGLE  INTEGRAL 
	UOUT = 0.d0

      DO 620 M=1,NIKZEN
      XX=M
      XX=XX/(NIKZEN+1.D0)
      XX=XX*3.14159265358D0
      XX=DCOS(XX)
      VXX=XX
      W=NIKZEN+1.D0
      W=3.14159265358D0/W*(1.D0-XX*XX)
      WEIHT=W
      X=(1.D0-VXX)/2.D0
        K1   =  KHE
         LV=  LHE
         L1  = L1HE1
         L2  = L2HE2
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ1,0)
 
       K1   =  KLI
         LV=  LLI
         L1  = L1LI1
         L2  = L2LI2
      CALL GG(K1,LV,0,L1,L2,X,FI1,TE1,FI2,TE2,PJ2,0)
c
      UOUT=UOUT+WEIHT*PJ1*PJ2/8.D0
 
620   CONTINUE


C RADIAL INTEGRAL .1 -  TO RMAX
       SU = (0.e0,0.e0)

      DO  IR=1,NX
         R12 = rrade(IR)
	 H  = wrade(IR)
         IF(IR.GE.IMAGS)GO TO 310
          FULLL = FUL(NSL,IR)
            GO TO 311
 310      FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(NX*DR-R12))
 311    SU  = FUH(NSIMP,NSH,IR) * FULLL * H  + SU
      ENDDO

	SU = SU*PHASE

ccc          WRITE(4,1120)KHE,LHE,L1HE1,L2HE2,UOUT,SU,K1,LV,L1,L2
ccc          WRITE(4,1120)KHE,LHE,L1HE1,L2HE2,
ccc     X                 AS,RRCHE(J1,I1),RRCLI(M1,N1),K1,LV,L1,L2
1120  FORMAT(' <HE:K,LL,L1,L2=',4I2,'|NORM=',3G11.3,'|LI: ',4I2,'>')

      SU = SU*UOUT 

       FUR(NSIMP) = FUR(NSIMP) + 
     *       SU*AS*RRCHE(J1,I1)*RRCLI(M1,N1) * INOR

791   CONTINUE
891   CONTINUE

c *** End of continuum   (fin) loop

1102  CONTINUE

c *** End of bound state (ini) loop
1101  CONTINUE


c *** End of impuls loop
9101  CONTINUE

c     WRITE(4,1518) JHE,MJHE,L,ISIG,J,MJ,JLI,MJLI
1518  FORMAT(1X,'<JF,MJF=',2I3,'|L, S ,J,MJ=',4I3,'|JI,MJI=',2I3,'>'/)
      AC= (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0)
       AC= WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * AC
c     WRITE(4,1918) JLI,MJLI,J,MJ,JHE,MJHE,AC
1918  FORMAT(1X,'<JL,MJL=',2I3,'J,MJ=',2I3,'|JH,MJH=',2I3,'>=',F5.3/)

	   UOUT = 0.d0

         DO  KLS = 1,NOP

           SH(KLS) = cabs(FUR(KLS))**2 * DEN*WFN/XAP
	    UOUT = UOUT + SH(KLS)

	  enddo
c
c *** Printout of strength functions:

         dSdE = UOUT
       WRITE(28,9515) ec,dSdE,(SH(KLS),KLS = 1,min(NOP,6))
C
 9515 FORMAT(3X,f8.3, g14.4, 3x,6G12.3) 
ccc        write(4,*) 'SF factor at EC',real(EC),' =',DEN*WFN/XAP
      RETURN
1111   WRITE(4,1112)
1112   FORMAT(1X,' !!!!  ERROR : MJLI + MJ .NE. MJHE  !!!!!'/)
      RETURN
9902   WRITE(4,9912)
       WRITE(6,9912)
9912   FORMAT(1X,' !!!!  ERROR :  SLI + SHE + TLI+THE ODD !'/)
      RETURN
      END
c
c
c ##########################################################################
c ##########################################################################
c
      SUBROUTINE ANGSPI2(S1,S2,L1H,L2H,LHE,ISHE,JHE,MJHE,L ,ISIG,J,MJ,
     *                  L1L,L2L,LLI,ISLI,JLI,MJLI,AS)
        IMPLICIT REAL*8(A-H,O-Z)
C *********************************************************************
C       SPIN - ANGULAR MATRIX ELEMENT FOR DENSITY OPERATOR            *
C               < L,M, SIG,M(SIG)/J,M(J)>                             *
C             IT ACTS ON A SUBSYSTEM 2    (L1H = L1L)                 *
C          CASE OF NUCLEON  S1 = S2 = 1/2      *
C *********************************************************************
C                                                                     *
        IF((MJLI + MJ ) .NE. MJHE) GO TO 1000
            PI = 3.14159
        IF(L .NE. 0)  GO TO 100
        IF(L2H .NE. L2L) GO TO 1000
        IF((L .EQ. 0)  .AND.( ISIG .EQ.0))GO TO 1003
 100     RMES =  DSQRT(6.D0)
        IF(ISIG .EQ. 0) RMES = DSQRT( 2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
         RMEL =  DSQRT(  2* L2L+1.D0)*RMEL
         RMEL =  DSQRT(  2* L  +1.D0)*RMEL
         WIG1 =                 WIG(2*L2H,2*L,2*L2L,0,0)
          IF(WIG1 .EQ. 0.D0) GO TO 1000
C            WRITE(7,8)L2H,L,L2L,WIG1
    8    FORMAT('WIG: L2H,L,L2L=',3I3,G12.3/)
         RMEL =  (-1)**L2H*RMEL*WIG1/DSQRT(4.D0*PI)
                  GO TO 1002
 1001    RMES =  DSQRT(2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
 1003     AS = 1.D0/DSQRT(4.D0*PI)
      IF(LLI .NE. LHE) AS = 0.D0
      IF(ISHE.NE.ISLI) AS = 0.D0

      RETURN
 1002     CONTINUE
C
C   ****  NUCLEON CASE : S1 = S2 = 1/2     S1+S2 = 1
C
        IF( L )211,211,212
  211   A = (-1)**(1+ ISHE+ISIG)*
     *  WRACA(.5D0 ,.5D0 ,1.D0*ISIG,1.D0*ISHE,1.D0*ISLI,.5D0    )
         A = A*RMES*RMEL
        A =   1.D0/DSQRT(2.D0*ISIG+1.D0)
     *                             /DSQRT(2.D0*L2H+1.D0) * A
         IF(JHE .EQ. 0) GO TO 213
         IF(JLI .EQ. 0) GO TO 214
          GO TO 215
C *** CASE JHE = 0
  213    IF(LLI .NE.LHE)GO TO 1000
         IF(ISHE.NE.LHE)GO TO 1000
         IF(JLI .NE. J )GO TO 1000
         A = (-1)**(JHE + ISLI +LHE+ISHE +1 + J )*A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         AS = DSQRT( 2.D0*JLI  + 1.D0) * A
             RETURN
C *** CASE JLI = 0
  214    IF(LLI .NE.LHE)GO TO 1000
         IF(ISLI.NE.LLI)GO TO 1000
         IF(JHE .NE. J )GO TO 1000
         A = (-1)**(JHE + ISLI +LLI+ISHE +1 + J )*A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         AS = DSQRT( 2.D0*JLI  + 1.D0) * A
             RETURN
C *** CASE JHE > 0  , JLI > 0
  215    IF(LLI .NE.LHE)GO TO 1000
         A = (-1)**(JHE + LHE +1 )*A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         A  = DSQRT( 2.D0*J    + 1.D0) * A
         A  = DSQRT( 2.D0*JLI  + 1.D0) * A
        AS = (-1)**(JLI+JHE+ISLI+ISHE)*
     *  WRACA(1.D0*ISHE,1.D0*ISLI,1.D0*JHE,1.D0*JLI,1.D0*J,1.D0*LLI)*A
             RETURN
C ***
C *** CASE  L  > 0  ,ISIG = 0  , J = ISIG
  212   IF(ISIG)311,311,312
  311     IF(ISLI.NE. ISHE) GO TO 1000
         A = (-1)**(L1H +L2L+ISHE + J + JLI -L )*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
         A = A/DSQRT( 2.D0)
        A = (-1)**(L2L+L1L+LHE+L)*
     *  WRACA(1.D0*L2L,1.D0*L1L,1.D0*L,1.D0*LHE,1.D0*LLI,1.D0*L2H) * A
        AS= (-1)**(LLI+LHE+JHE+JLI)*
     *  WRACA(1.D0*JHE,1.D0*JLI,1.D0*LHE,1.D0*LLI,1.D0*J,1.D0*ISHE)* A
             RETURN
C ***
C *** CASE  L  > 0  ,ISIG > 0
  312    A = (-1)**(L1H +L2L -LHE + 1 +ISLI -L - ISIG)*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*ISHE + 1.D0) * A
         A = DSQRT( 2.D0*ISLI + 1.D0) * A
         A = DSQRT( 2.D0*J    + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
C    ***  WIG,RAKAH,9-J
C     A = (-1)**(-JLI+J-MJHE)*DSQRT(2.D0*JHE + 1.D0) * A
C      A = WIG(2*JLI,2*J,2*JHE,2*MJLI,2*MJ ) * A
        A = (-1)**(L2L+L1L+LHE+L)*
     *  WRACA(1.D0*L2L,1.D0*L1L,1.D0*L,1.D0*LHE,1.D0*LLI,1.D0*L2H) * A
        A = (-1)**(1+ ISHE+ISIG)*
     *  WRACA(.5D0 ,.5D0 ,1.D0*ISIG,1.D0*ISHE,1.D0*ISLI,.5D0    ) * A
C
C   CHECK ON JF > 0
C
        IF(JHE) 11, 11, 12
   11     IF(LHE .NE. ISHE) GO TO 1000
          IF(JLI .NE. J   ) GO TO 1000
        A = (-1)**(L +LHE+ISLI+JLI)/DSQRT(2.D0*JLI+1.D0)
     *                             /DSQRT(2.D0*LHE+1.D0) * A
        AS = (-1)**(LLI+L +ISLI+ISIG)*
     *  WRACA(1.D0*LLI,1.D0*L,1.D0*ISLI,1.D0*ISIG,1.D0*LHE ,1.D0*JLI)*A
              GO TO 13
C *** CASE JHE > 0
C
  12    IF(JLI)111,111,112
  111     IF(LLI .NE. ISLI) GO TO 1000
          IF(JHE .NE. J   ) GO TO 1000
        A = (-1)**(J +LHE+ISIG+LLI)/DSQRT(2.D0*J  +1.D0)
     *                             /DSQRT(2.D0*LLI+1.D0) * A
        AS = (-1)**(LHE+L +ISHE+ISIG)*
     *  WRACA(1.D0*LHE,1.D0*L,1.D0*ISHE,1.D0*ISIG,1.D0*LLI ,1.D0*J  )*A
              GO TO 13
C *** CASE JHE > 0 , JLI > 0
C
  112      B1 = (LHE)
           B2 = (LLI)
           B3 = (L)
           B4 = (ISHE)
           B5 = (ISLI)
           B6 = (ISIG)
           B7 = (JHE)
           B8 = (JLI)
           B9 = (J)
        AS= SIM9J(B1,B2,B3,B4,B5,B6,B7,B8,B9) * A
   13        RETURN
 1000     AS = 0.D0
             RETURN
                END
  
