      subroutine coul (fl,z,e,r,fx,fxp)
      implicit integer (a-z)
      real*8 z,e,r,fx,fxp,xg,xgp,one,half,two,eps,ak,cx,fx1,flt,
     x       fl0,fl,c1,q,f1,f2,f3,an,efx,fac,f,ef,epf,efxp,spad,fp,
     x       spadp,zero,lastfl,lastcx,flast,fplast
      parameter (one=1.0d0,half=0.5d0,two=2.0d0,eps=1.0d-04,zero=0.0d0)
      parameter (nterm=80)
      dimension spad(nterm+2,nterm+2),spadp(nterm+2,nterm+2)
	save lastfl,lastcx
*
*     coul : whittaker function and derivative using the asymptotic
*	     expansion converted to a continued fraction
*            Modified IJT to NOT use z scaling, to allow z=0 case too.
*            Modified IJT to use recursion up to fl required
*            Modified IJT to use epsilon algorithmn.
*
      iout =6
      nt = nterm + 1
      ak = sqrt(-e)
      cx = ak * r
c     fl = dble(l)
	mfl = int(fl)
      fl0 = fl - mfl
      c1 = z/ak
      q = one
      xg = q
      xgp = zero
	f = xg
	fp= xgp
      call epsilon (xg,1,spad,f,nterm+2)
      call epsilon (xgp,1,spadp,fp,nterm+2)
      f1 = fl0 - c1
      f2 = - (fl0+one) - c1
      f3 = - half / cx 
      do 10 n = 1, nterm
	 an = dble(n)
	 q = (f1 + an) * (f2 + an) * f3 * q / an
	 xg = xg + q 
         xgp = xgp - an *  q / r
	flast = f
	fplast= fp
      call epsilon (xg,n+1,spad,f,nterm+2)
      call epsilon (xgp,n+1,spadp,fp,nterm+2)
	ef = 0.
	epf = 0.
	if(f.ne.0d0) ef = abs(f-flast)/abs(f)
	if(fp.ne.0d0) epf= abs(fp-fplast)/abs(fp)
      if (abs(ef) .lt. eps .and. abs(epf) .lt. eps) go to 11
   10 continue
   11 fac = exp(-cx) * (two * cx) ** c1
      fx = fac * f
      efx = abs(ef*fx)
      fxp = ((z / cx - ak) * fx + fac * fp)
      efxp = abs(epf*fxp)
      if (abs(ef) .gt. eps .or. abs(epf) .gt. eps) then
	if(abs(fl-lastfl).gt.eps.or.abs(cx-lastcx).gt.eps) then
	  write(iout,1030) fl,cx,n,fx,fxp,ef,epf
	 endif
	lastfl = fl
	lastcx = cx
      endif
      do 20 il=1,mfl
	 flt = fl0+il
	 q = flt/cx - c1/flt
	 fx1 = flt/(flt - c1) * (q * fx - fxp)
	 fxp = (- c1/flt - one) * fx - q * fx1 
	 fx  = fx1
20	continue
      return
*
 1000 format (' nterm =',i6,/,' xg: ',/,(4d16.8))
 1010 format (' coul : fx  =',d16.8,' efx  =',d16.8,' eps =',d16.8,/,
     x        '        fxp =',d16.8,' efxp =',d16.8)
 1020 format (' nterm =',i6,/,' xgp: ',/,(4d16.8))
 1030 format (' Whit error: l,rho =',f6.1,f8.3,i4,1p,2e12.4,':',2e10.2)
      end
      subroutine epsilon(sum,itnl,spad,sac,maxit2)
      implicit real*8(a-h,o-z)
      dimension spad(maxit2,maxit2)
c
c               this is the Pade approximant by the epsilon algorithm
c               -----------------------------------------------------
      spad(itnl,1) = 0.0
      spad(itnl,2) = sum
c
      it1 = itnl + 1
      do 460 j=3,it1
      it = itnl + 2 - j
      t =  spad(it+1,j-1) - spad(it,j-1)
         c6 = 0.
         if(t.ne.0d0) c6 = 1d0/t
  460 spad(it,j) = spad(it+1,j-2) + c6
      sac = spad(it1-it1/2*2+1, it1/2*2)
      return
      end
