**********************************************************************
      function fival(r,xv,fdis,ndm)
************************************************************************
*     real 4-point lagrange interpolation routine.
*     interpolates thr function value fival at point r from an
*     array of points stored in fdis(ndm). this array is assumed
*     to be defined such that the first element fdis(1) contains
*     the function value at r=xv(1) and xv(2 .. ndm) are monotonically
*     increasing.
************************************************************************
      implicit real*8 (a-h,o-z)
      real*8 fdis(ndm),y1,y2,y3,y4
      dimension xv(ndm)
      if(r.gt.xv(ndm)) go to 9
      do 5 k=1,ndm-2
 5    if(r.lt.xv(k)) go to 6
      k=ndm-1
 6    nst=max(k-2,1)
      x1=xv(nst)
      x2=xv(nst+1)
      x3=xv(nst+2)
      x4=xv(nst+3)
      y1=fdis(nst+0)
      y2=fdis(nst+1)
      y3=fdis(nst+2)
      y4=fdis(nst+3)
      pii1=(x1-x2)*(x1-x3)*(x1-x4)
      pii2=(x2-x1)*(x2-x3)*(x2-x4)
      pii3=(x3-x1)*(x3-x2)*(x3-x4)
      pii4=(x4-x1)*(x4-x2)*(x4-x3)
      xd1=r-x1
      xd2=r-x2
      xd3=r-x3
      xd4=r-x4
      pi1=xd2*xd3*xd4
      pi2=xd1*xd3*xd4
      pi3=xd1*xd2*xd4
      pi4=xd1*xd2*xd3
      fival=y1*pi1/pii1+y2*pi2/pii2+y3*pi3/pii3+y4*pi4/pii4
      return
 9    fival=fdis(ndm)
      return
      end
