	subroutine invitr(A,ia,n,B,ib,sym,on,nst,val,vec,E1,DE,eps,mc)
	implicit real*8(a-h,o-z)
	dimension A(ia,n),B(ib,n),vec(n),rhs(n),p(n)
	integer p
 	logical on,sym
	parameter (zero=0d0, one=1d0)
c
c	Find eigensolution nearest to E1 for Ax=EBx 
c	by inverse iteration:  [A-E1.B] x(n) = B x(n-1)
c	
c	If on=true, assume B=unit matrix (B not used)
c	Do not assume A & B are symmetric matrices, 
c	At end, val=E, vec=x, A destroyed, B kept
C
	EIT = E1
 	do 10 i=1,n
	if(on) then
	  A(i,i) = A(i,i) - EIT
	else
	  do 5 j=1,n
5 	  A(i,j) = A(i,j) - EIT*B(i,j)
	endif
10	continue
	write(6,15) EIT
15	format(/' Inverse iteration to find eigenstate nearest',F10.5)

c			L.R decomposition otherwise
	  call dgetrf(n,n,A,ia,p,ifail)
	if(ifail.ne.0) then
	     write(6,*)' Singular Matrix decomposition for this energy'
	     stop 'invitr'
	endif
c			starting vector
	do 20 i=1,n
20	rhs(i)=zero
	j = min(3,n/nst)
	j = max(1,j)
	wn = j
	do 21 i=1,j
21	rhs(1+(i-1)*nst) = one/sqrt(wn)
	E = zero
		
	do 100 ic=1,mc
	  elast = E
	   do 25 i=1,n
25	     vec(i) = rhs(i)
          call dgetrs('N',n,1,A,ia,p,vec,n,info)
	wn = zero
	do 30 i=1,n
30	wn = wn + vec(i)*rhs(i)
	do 50 i=1,n
	if(on) then
	   rhs(i) = vec(i)
	else
	   an = zero
	   do 40 j=1,n
40	      an = an + B(i,j)*vec(j)
	   rhs(i) = an
	endif
50	continue
	an=zero
	do 60 i=1,n
60	  an = an + vec(i)*rhs(i)
	E = EIT + wn/an
	write(6,80) ic,E,E-elast
80	format(' Iteration ',I4,' gives ',F10.5,', change =',1P,E10.2)
	call flush(6)
	an = one/sqrt(an)
	do 70 i=1,n
70	  rhs(i) = rhs(i) * an
	val = E
	if(ic.gt.3 .and. abs(E-elast).lt.eps) go to 200
100	continue
	write(6,*) ' Inverse iteration for ENGY failed after',
     X                  mc,' iterations'
	stop
200	do 210 i=1,n
210	vec(i) = vec(i) * an
	write(6,220) E
220	format('  Inverse iteration for engy gives',f10.5,' MeV')
	return
	end
