      subroutine gpropi (rmato,rmat,no,gbar,rstart,rend)
      implicit integer (a-z)
      integer n,no,nop,ipvt,n2,n2p,nh,i,ier,iin,iout,k,n2r
      double precision gbar,a1,a2,zero,one,rmat,rstart,rend,rmato
      parameter ( zero=0.0d0,one=1.0d0 )
      common /dimrmat/ MCHAN3
      dimension gbar(no*no*4),a1(no,no),a2(no,no),ipvt(no),
     X		rmato(MCHAN3,MCHAN3),rmat(MCHAN3,MCHAN3)
      common /io/ iin,iout
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
*
*		Using global propagator gbar:
*		Derive R at REND from R at RSTART
*		Overwrite RMAT
*
*     g11 = gbar; g12 = gbar(n2p); g22 = gbar(nh); g21 = gbar(n2r)
*
!	write(6,*) ' gpropi: find R from ',rstart,' to ',rend

      do 10 j = 1, no
      do 10 i = 1, no
10          a2(i,j) =  - rstart * rmato(i,j)

      n2 = no * no
      n2p = n2 + 1
      nh = n2 + n2p
      n2r = n2 + nh

	do 20 i=1,no
	do 20 j=1,no
	  kk = i + (j-1)*no - 1
20	a1(i,j) = gbar(nh+kk) + a2(i,j)
      call dgetrf (no,no,a1,no,ipvt,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1000) ier
	 stop
      endif
      if(SYMM) then
      call transp (gbar(n2p),a2,no,no)
	else
      call dcopy (n2,gbar(n2r),1,a2,1)
	endif
      call dgetrs ('n',no,no,a1,no,ipvt,a2,no,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      call dcopy (n2,gbar,1,a1,1)
      call  dgemm ('n','n',no,no,no,one,gbar(n2p),no,a2,no,-one,a1,no)

      do 30 j = 1, no
      do 30 i = 1, no
30          rmat(i,j) =  + a1(i,j) / rend
      return
 1000 format (' gpropi : error return from dgetrf, ier =',i4)
 1010 format (' gpropi : error return from dgetrs, ier =',i4)
      end
      subroutine lwfprp (keep,nstp,nmatch,nmax,etot,debug,rfinal,idiscr,
     x                    f,fp,et,npop,lchl,wfin,lwgf,WFNR,mchan,NR)
	use globals, only: cf,potcoef,npots
      implicit integer (a-z)
      double precision enrg,tev,tpev,dchan,etot,a1,a2,a3,a4,r,rfinal,
     x                 dr,rl,gbar,f,fp,et,sk,eta,tsave,ABL,g,fw,gw,WFNR
      logical debug,wfin,prg,uncup
      dimension enrg(nmax),tev(nmax,nmax),eta(nmax),dchan(nmax,2),
     x          a1(nmax,nmax),a2(nmax,nmax),a3(nmax,nmax),a4(nmax,nmax),
     x          gbar(nmax,nmax,4),tpev(nmax,nmax),ipvt(nmax),keep(nstp),
     x          f(nmax,nmax,4),fp(nmax,nmax,4),et(nmax),sk(nmax),
     x          tsave(nmax,nmax),lchl(nmax),lwgf(*),
     x		WFNR(mchan,mchan,NR+1)
	real*8 flj,fl0,rr,wrerrm(2,nmax),fx,fxp
	real*8 ryev,scent
!	real*8 fc(201),gc(201),fcp(201),gcp(201),fch(101),fpch(101)
	common/cent/scent,ryev
	parameter (ncrit=4)
	ABL(R) = LOG10(MAX(ABS(R),1D-20))
	prg = debug
*
*     lwfprp : lw r-matrix function inward propagator 
*              keep(nstep) = channels retained at each step.
*
      n = keep(nstp)
      do 10 i = 1, nmax
         sk(i) = sqrt(abs(et(i)))
         eta(i) = 0d0
         do np=1,npots
         eta(i) = eta(i)  + cf(i,i,1,np)*potcoef(np)
	 enddo
         eta(i) = eta(i) / (2d0 * sk(i))
   10 continue
      nold = n
      read (idiscr, rec = nstp) r,dr,enrg,tsave,tev,tpev
	IR = NR
         if (wfin.and.lwgf(nstp).gt.0) then
	  rr = r+dr
	  do 11 i=1,n
	  do 11 j=1,n
11	  WFNR(i,j,IR) = f(i,j,1)
	  IR=IR-1
      	  call WRONSK3 (nmax,nmax,f(1,1,1),fp(1,1,1),1,et,wrerrm)
c 	  write(69,16) rr,(ABL(wrerrm(1,i)),i=1,min(nmax,16))
c         write(60,16) rr,(ABL(f(i,i,1)),i=1,min(n,16))
	 endif

      call rpropi (enrg,dr,etot,dchan,n,nmax,gbar,a1,a2,tev,tpev,prg)

      do 20 nstep = nstp-1, nmatch+1, -1
         n = keep(nstep)
c	 n = min(n,nold)
         read (idiscr, rec = nstep) rl,dr,enrg,tsave,tev,tpev
	 rr = rl+dr
!        write(3,*) 'Propagating sc',nstep,' @',
!    x              real(rr),' with ',n,' chs',nold
         if (debug) call printm ('tev ',tev,n,n,nmax)

         if (wfin.and.lwgf(nstep).gt.0) then
c	  
	  call dcopy(nmax*nmax,f(1,1,1),1,f(1,1,3),1)
	  call dcopy(nmax*nmax,fp(1,1,1),1,fp(1,1,3),1)
          call propf (n,nold,nmax,npop,a1,a2,ipvt,f(1,1,3),fp(1,1,3),
     X			gbar,rl,sk,lchl,eta,1)
	  do 12 i=1,n
	  do 12 j=1,n
12	  WFNR(i,j,IR) = f(i,j,3)
	  IR = IR-1
      	call WRONSK3 (nmax,nmax,f(1,1,3),fp(1,1,3),1,et,wrerrm)
c  	write(69,16) rr,(ABL(wrerrm(1,i)),i=1,min(nmax,16))
	call chops(69)
  	write(69,16) rr,(ABL(wrerrm(1,i)),i=max(1,nmax-15),nmax)

c	if(et(1).lt.0) then
c	  do 14 i=1,n
c	    flj = lchl(i) + scent
c            call coul2 (flj,eta(i)*sk(i),sk(i),rr,fx,fxp,0,1)
c              fch(i)  = fx 
c  14          fpch(i) = fxp
c	endif
	    call chops(60)
            write(60,16) rr,(ABL(f(i,i,3)),i=1,min(n,16))
     X                     ,(20.,i=n+1,min(nmax,16))
   16       format(f8.2,16f7.2)
c            write(61,17) rr,(f(i,i,3)/(fch(i)+1d-99),i=1,min(n,16))
c            write(62,17) rr,(fp(i,i,3)/(fpch(i)+1d-99),i=1,min(n,16))
c            write(63,17) rr,(f(i,i,3),fch(i),i=1,min(n,3))
c  17         format(f8.2,1p,20e10.2)
	endif

         if ( n .ne. nold) then
            call propf (n,nold,nmax,npop,a1,a2,ipvt,f,fp,gbar,rl,sk,
     x                  lchl,eta,1)
            call rpropi (enrg,dr,etot,dchan,n,nmax,gbar,
     x			 a1,a2,tev,tpev,prg)
         else
            call rpropf (enrg,dr,etot,dchan,n,nmax,a1,a2,a3,a4,ipvt,
     x                   gbar,tev,tpev)
         endif
         nold = n
   20 continue
   21 rfinal = rl
      call propf(n,nold,nmax,npop,a1,a2,ipvt,f,fp,gbar,rl,sk,lchl,eta,1)
c         if (wfin.and.lwgf(nmatch).gt.0) then
         if (wfin) then
	  do 32 i=1,n
	  do 32 j=1,n
32	  WFNR(i,j,IR) = f(i,j,1)
      	  call WRONSK3 (nmax,nmax,f(1,1,1),fp(1,1,1),1,et,wrerrm)
c  	  write(69,16) rl,(ABL(wrerrm(1,i)),i=1,min(nmax,16))
  	  write(69,16) rl,(ABL(wrerrm(1,i)),i=max(1,nmax-15),nmax)
          write(60,16) rl,(ABL(f(i,i,1)),i=1,min(n,16))
	 endif
c	keep(nmatch)=nold
c       write(60,*) '&'
c        write(61,*) '&'
c        write(62,*) '&'
c        write(63,*) '&'
         write(69,*) '&'
	if(prg) then
         do 30 k=1,4
         write(6,*) 'LWFPRP: GBAR(**,',k,') at ',real(rfinal)
 30        call wrtmat(gbar(1,1,k),nmax,nmax,nmax,10)
	endif
c	uncup=.false.
c	if(uncup) then
c	  do 40 i=1,n
c	    flj = lchl(i) + scent
c            call coul2 (flj,eta(i)*sk(i),sk(i),rr,fx,fxp,0,1)
c	     do 35 j=1,n
c	     f(i,j,1) = 0
c35	     fp(i,j,1) = 0
c              f(i,i,1)  = fx 
c40            fp(i,i,1) = fxp
c	endif
      return
      end
      subroutine lwfprpo (nstart,nfinal,n,nmax,etot,debug,prg,idiscr,
     x			  gbar,wfin,lwgf)
      implicit integer (a-z)
      double precision enrg,tev,tpev,dchan,etot,a1,a2,a3,a4,r,
     x                 dr,gbar,tsave
      logical debug,wfin,prg
      dimension enrg(nmax),tev(nmax,nmax),dchan(nmax,2),
     x          a1(nmax,nmax),a2(nmax,nmax),a3(nmax,nmax),a4(nmax*nmax),
     x          gbar(nmax,nmax,4),tpev(nmax,nmax),ipvt(nmax),
     x          tsave(nmax,nmax),lwgf(*)
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
*
*     lwfprpo : find global outward lw r-matrix propagators
*
      read (idiscr, rec = nstart+1) r,dr,enrg,tsave,tev,tpev
c     write(3,*) 'LWFPRPO: Propagating ',nstart+1,' @',real(r),real(dr)
      if(nstart.eq.1) then
	call rpropi (enrg,-dr,etot,dchan,n,nmax,gbar,a1,a2,tev,tpev,prg)
      else
c				Remove final gbar for propof:
        backspace(idiscr+1) 
c				and carry on constructing gbar
        call rpropf (enrg,-dr,etot,dchan,n,nmax,a1,a2,a3,a4,ipvt,
     x                   gbar,tev,tpev)
      endif

      if(wfin.and.lwgf(nstart+1).gt.0) write(idiscr+1) r+dr,gbar
     
      do 20 nstep =  nstart+2, nfinal
         read (idiscr, rec = nstep) r,dr,enrg,tsave,tev,tpev
c         write(3,*) 'LWFPRPO: Propagating ',nstep,' @',real(r),real(dr)

         call rpropf (enrg,-dr,etot,dchan,n,nmax,a1,a2,a3,a4,ipvt,
     x                   gbar,tev,tpev)
          if(wfin.and.lwgf(nstep).gt.0) write(idiscr+1) r+dr,gbar
   20 continue
	if(prg) then
	 i=4
	 if(SYMM) i=3
         do 30 k=1,i
         write(6,*) 'LWFPRPO: GBAR(**,',k,') at ',real(r+dr)
 30        call wrtmat(gbar(1,1,k),nmax,nmax,nmax,10)
	endif
c				Save final gbar for propof:
      write(idiscr+1) r+dr,gbar
      return
      end
      subroutine mprint ( name, a, n, m, nmax )
      implicit integer (a-z)
      double precision a
      character*4 name
      dimension a(nmax,m)
      common /io/ iin,iout
*
*     mprint -- prints a real matrix a(n,m)
*		name	  -- 4 character identification
*		a(nmax,m) -- array to be printed
*		n	  -- number of rows to be printed
*		m	  -- number of columns to be printed ( .le. 10 )
*		nmax	  -- row dimension of a
*
      write (iout,1000) name, (a(1,i), i = 1, m)
      if ( n .gt. 1 ) then
	 do 10 i = 2, n
	    write (iout,1010) (a(i,j), j = 1, m )
   10	 continue
      endif
      return
*
c1000 format ( '0', a4, 2x, 10g12.4 )
c1010 format ( 7x, 10g12.4 )
 1000 format (  / , a4, 2x, 10f9.5 )
 1010 format ( 6x, 10f9.5 )
      end
      subroutine pot (r,nchan,v,nchx,ipmax,lchl,cf,mchan,ethr)
      implicit integer (a-z)
      double precision r,v,cf,ethr,zero,one,two,rk,elx,vc
      parameter ( zero=0.0d0,one=1.0d0,two=2.0d0 )
      dimension v(nchx,nchx),lchl(nchx),ethr(nchx),cf(mchan,mchan,ipmax)
      real*8 scent,ryev,vval
      common /cent/ scent,ryev
*
*     potential at radius r
*
      do 10 i = 1, nchan
      do 10 j = 1, nchan
         v(i,j) = zero
   10 continue
      vc = 0d0
	 do 54 j = 1, nchan
	 do 53 i = 1, nchan
               v(i,j) = v(i,j) + vval(i,j,r)/ryev
   53       continue
   54    continue

      rk = one / ( r * r )
      do 60 i = 1, nchan
	 elx = (lchl(i) + scent) * ( lchl(i) + 1 + scent)
	 v(i,i) = v(i,i) + elx * rk + ethr(i) + vc
   60 continue
      return
      end
      subroutine potp (r,nchan,v,nchx,ipmax,lchl,cf,mchan)
      implicit integer (a-z)
      double precision r,v,cf,zero,two,rk,elx,vc
      parameter ( zero=0.0d0,two=2.0d0 )
      dimension v(nchx,nchx),lchl(nchx),cf(mchan,mchan,ipmax)
      real*8 scent,ryev,vvald
      common /cent/ scent,ryev
*
*     potential gradient at radius r
*
      do 10 i = 1, nchan
      do 10 j = 1, nchan
         v(i,j) = zero
   10 continue
      vc =  0d0
	 do 54 j = 1, nchan
	 do 53 i = 1, nchan
               v(i,j) = v(i,j) + vvald(i,j,r)/ryev
   53       continue
   54    continue
      rk = two / r**3
      do 60 i = 1, nchan
	 elx =  (lchl(i)+scent) * ( lchl(i) + 1 + scent) 
	 v(i,i) = v(i,i) - elx * rk + vc
   60 continue
      return
      end
      subroutine printm (name,array,n,m,nmax)
      implicit integer (a-z)
      double precision array
      character*4 name,namec
      dimension array(*)
*
*     printm -- driver for mprint
*
      namec(1:4) = name(1:4)
      nh = 1
      mp = 10
      i = 0
      iz = ichar('0')
      do 10 nl = m, 1, -mp
         nc = min( nl, mp )
         call mprint (namec,array(nh),n,nc,nmax)
         i = i + 1
         namec(4:4) = char(iz+mod(i,10)) 
         nh = nh + nmax * nc
   10 continue
      end
      subroutine propf (n,no,nmax,nop,a1,a2,ipvt,f,fp,gbar,rr,sk,
     x                  lchl,eta,I0M)
      implicit integer (a-z)
      integer n,no,nmax,nop,ipvt,n2,n2p,nh,i,ier,iin,iout,np,ii,nn
      double precision f,fp,gbar,a1,a2,zero,one,rr,sk,eta
      parameter ( zero=0.0d0,one=1.0d0 )
      dimension gbar(nmax*nmax*4),f(nmax*nmax*2),fp(nmax*nmax*2),
     x          a1(nmax*nmax),a2(nmax*nmax),ipvt(nmax),sk(nmax),
     x          eta(nmax)
      common /io/ iin,iout
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
      real*8 scent,ryev
      dimension lchl(nmax)
      common /cent/ scent,ryev
*
      n2 = no * no
      n2p = n2 + 1
      nh = n2 + n2p
      n2r = n2 + nh
      nx = nmax * nmax
      nx1 = nx + 1
      if(SYMM) call transp (gbar(n2p),a1,no,no)
      if(.not.SYMM) call dcopy (n2,gbar(n2r),1,a1,1)
      call dgetrf (no,no,a1,no,ipvt,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1000) ier
	 stop
      endif
      call  dgemm ('n','n',no,no,no,one,gbar(nh),no,fp,nmax,-one,f,
     x             nmax)
      call dgemm ('n','n',no,no,no,one,gbar(n2p),no,fp,nmax,zero,a2,
     x            nmax)
      call dcopy (nx,f,1,fp,1)
      call dgetrs ('n',no,no,a1,no,ipvt,fp,nmax,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      call dcopy (nx,a2,1,f,1)
      call  dgemm ('n','n',no,no,no,-one,gbar,no,fp,nmax,one,f,nmax)
*
      if(I0M.eq.2) then
      call  dgemm ('n','n',no,no,nop,one,gbar(nh),no,fp(nx1),nmax,-one,
     x             f(nx1),nmax)
      call dgemm ('n','n',no,no,nop,one,gbar(n2p),no,fp(nx1),nmax,zero,
     x            a2,nmax)
      call dcopy (nx,f(nx1),1,fp(nx1),1)
      call dgetrs ('n',no,nop,a1,no,ipvt,fp(nx1),nmax,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      call dcopy (nx,a2,1,f(nx1),1)
      call  dgemm ('n','n',no,no,nop,-one,gbar,no,fp(nx1),nmax,one,
     x             f(nx1),nmax)
      endif
*
*     channel pickup
*
      if ( n .gt. no ) then
         nn = (n-1)*nmax
         np = nn + n
         do 30 i = 1, n
            ii = nn + i
            f(ii) = zero
            fp(ii) = zero
   30    continue
         do 40 i = 1, n
            ii = (i-1)*nmax + n
            f(ii) = zero
            fp(ii) = zero
c            f(ii+nx) = zero
c            fp(ii+nx) = zero
   40    continue
         call cpk2(n,f(np),fp(np),rr,sk,eta,lchl(n)+scent,nmax)
      endif
      return
 1000 format (' propf : error return from dgetrf, ier =',i4)
 1010 format (' propf : error return from dgetrs, ier =',i4)
      end
      subroutine propof (no,nop,nmax,f,fp,rr,rmat,idiscr)
      implicit integer (a-z)
      integer n,no,nmax,ipvt,i,ier,iin,iout,ii,nn
      double precision f,fp,gbar,a1,a2,a3,zero,one,rr,rmat,r
      parameter ( zero=0.0d0,one=1.0d0)
      common /dimrmat/ MCHAN3
      dimension gbar(no,no,4),f(nmax,nmax,2),fp(nmax,nmax,2),
     x          a1(no,no),a2(nmax*nmax),ipvt(nmax),
     x          rmat(MCHAN3,MCHAN3),a3(nmax*nmax)
      common /io/ iin,iout
      real*8 EE
      COMMON /IE/ EE,IERR
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
*
        nx = nmax * nmax
c				Get saved final gbar:
      backspace(idiscr+1)
      read(idiscr+1) r,gbar
c
c	Propagate regular solution inward using precomputed rmat

	if(.false.) then
 	write(6,*) 'Propof at',real(rr)
         write(6,1) 'rmat',(rmat(k,k),k=1,4)
 	write(6,1) 'g11',(gbar(i,i,1),i=1,min(no,4))
 	write(6,1) 'g12',(gbar(i,i,2),i=1,min(no,4))
 	write(6,1) 'g22',(gbar(i,i,3),i=1,min(no,4))
 	write(6,1) 'g21',(gbar(i,i,4),i=1,min(no,4))
 1	format(1x,a6,1p,10e10.2)
   40   format(f9.4,10f14.5)
	endif
c       write(75,40) EE,(F(1,1,K),K=1,2),(FP(1,1,K),K=1,2)

	do 2 i=1,no
	do 2 j=1,no
2	 a1(i,j) =  gbar(i,j,3) - rr*rmat(i,j)

      call dgetrf (no,no,a1,no,ipvt,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1000) ier
	 stop
      endif
      do k=1,2
*			Real & imag parts respectively
      if(SYMM) then
      call  dgemm ('t','n',no,nop,no,one,gbar(1,1,2),no,fp(1,1,k),nmax,
     x			zero,a2,nmax)
      call dgetrs ('n',no,nop,a1,no,ipvt,a2,nmax,ier)
      call  dgemm ('t','n',no,nop,no,-one,gbar(1,1,2),no,fp(1,1,k),nmax,
     x			zero,a3,nmax)
      else
      call  dgemm ('n','n',no,nop,no,one,gbar(1,1,4),no,fp(1,1,k),nmax,
     x			zero,a2,nmax)
      call dgetrs ('n',no,nop,a1,no,ipvt,a2,nmax,ier)
      call  dgemm ('n','n',no,nop,no,-one,gbar(1,1,4),no,fp(1,1,k),nmax,
     x			zero,a3,nmax)
      endif
      call dcopy (nx,a2,1,fp(1,1,k),1)

***   call  dgemm ('n','n',no,nop,no,rr,rmat,no,a2,nmax,
***  x			zero,f(1,1,k),nmax)
*			
*			Use ordinary formula for F, valid even if FP near zero
      call dcopy (nx,a3,1,f(1,1,k),1)
      call  dgemm ('n','n',no,nop,no,one,gbar(1,1,3),no,fp(1,1,k),nmax,
     x			one,f(1,1,k),nmax)
c	write(90,1) 'f',(f(i,i,k),i=1,min(no,4,nop))
c	write(90,1) 'fp',(fp(i,i,k),i=1,min(no,4,nop))
      enddo
c       write(76,40) EE,(F(1,1,K),K=1,2),(FP(1,1,K),K=1,2)
	
      return
 1000 format (' propof : error return from dgetrf, ier =',i4)
 1010 format (' propof : error return from dgetrs, ier =',i4)
      end
      subroutine propwf (r,no,nmax,nop,f,fp,idiscr)
      implicit integer (a-z)
      integer no,nmax,nop,ipvt,i,ier,iin,iout
      double precision f,fp,gbar,a1,a2,zero,one,r
      parameter ( zero=0.0d0,one=1.0d0 )
      dimension gbar(no,no,4),f(nmax,nmax,4),fp(nmax,nmax,4),
     x          a1(no,no),a2(nmax*nmax),ipvt(nmax)
      common /io/ iin,iout
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
*
        nx = nmax * nmax
*
*	Regular solution f(**,1:2) outward using global propagator to f(**,3:4)
*
      read(idiscr+1) r,gbar
      if(SYMM) call transp (gbar(1,1,2),a1,no,no)
      if(.not.SYMM) call dcopy (no*no,gbar(1,1,4),1,a1,1)
      call dgetrf (no,no,a1,no,ipvt,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1000) ier
	 stop
      endif
*
      do i=1,2
	j=i+2
c					From f(1,1,i) to f(1,1,j)
      call dcopy (nx,f(1,1,i),1,f(1,1,j),1)
      call  dgemm ('n','n',no,nop,no,one,gbar(1,1,3),no,fp(1,1,i),nmax,
     x	   	   -one,f(1,1,j),nmax)
      call dgemm ('n','n',no,nop,no,one,gbar(1,1,2),no,fp(1,1,i),nmax,
     x		   zero,a2,nmax)
      call dcopy (nx,f(1,1,j),1,fp(1,1,j),1)
      call dgetrs ('n',no,nop,a1,no,ipvt,fp(1,1,j),nmax,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      call dcopy (nx,a2,1,f(1,1,j),1)
      call  dgemm ('n','n',no,nop,no,-one,gbar,no,fp(1,1,j),nmax,one,
     x             f(1,1,j),nmax)
      enddo
      return
 1000 format (' propwf : error return from dgetrf, ier =',i4)
 1010 format (' propwf : error return from dgetrs, ier =',i4)
      end
      subroutine rpropf (en,du,e,dchan,n,nmax,a1,a2,a3,a4,ipvt,gbar,
     x                   tev,tpev)
      implicit integer (a-z)
      integer n,nmax,i,j,n2,n2p,nh,ier,ipvt,ij
      double precision dchan,zero,one,a1,a2,a3,a4,en,du,e,ek,hek,s,sh,
     x                 ch,gbar,tev,tpev
      parameter ( zero=0.0d0,one=1.0d0 )
      common /io/ iin,iout
      dimension dchan(2*nmax),gbar(nmax*nmax*4),en(nmax),a1(nmax*nmax),
     x		a2(nmax*nmax),a3(nmax*nmax),a4(nmax*nmax),ipvt(nmax),
     x          tev(nmax,nmax),tpev(nmax,nmax)
      LOGICAL SYMM
      COMMON /XPROP/ SYMM,NSURF
*
*     global r-matrix propagation
*
      do 10 i = 1, n
	 ek = e - en(i)
	 if ( i .gt. nsurf) then
           dchan(i) = zero
	   dchan(n+i) = zero
         else 
	   if ( ek .ge. zero ) then
	    ek = sqrt(ek)
	    hek = du * ek
	    s = - one
	    sh = sin(hek)
	    ch = cos(hek)
	   else
	    s = one
	    ek = sqrt(-ek)
	    hek = du * ek
	    sh = sinh(hek)
	    ch = cosh(hek)
	   endif
	   dchan(i) = one / ( s * sh * ek )
	   dchan(n+i) = ch * dchan(i)
	 endif
   10 continue
*
*     s12, s21 = dchan ; s11, s22 = dchan(n+1)
*     g11 = gbar; g12 = gbar(n2p); g22 = gbar(nh); g21 = gbar(n2r)
      n2 = n * n
      n2p = n2 + 1
      nh = n2 + n2p
      n2r = n2 + nh
*     transform to coupled representation
      do 20 ij = 1, n2
         j = (ij-1)/n + 1
         i = ij - (j-1) * n
         a3(ij) = dchan(n+i) * tpev(i,j)
         a4(ij) = dchan(i) * tpev(i,j)
   20 continue
      call dgemm ('n','n',n,n,n,one,tev,nmax,a3,n,zero,a1,n)
      call dgemm ('n','n',n,n,n,one,tev,nmax,a4,n,zero,a2,n)
*     form z inverse
      do 40 ij = 1, n2
         a3(ij) = a1(ij) + gbar(ij)
   40 continue
      call dgetrf (n,n,a3,n,ipvt,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1000) ier
c	 ier = 1/min(ier,0)
	 write(6,*) 'a1'
         call wrtmat(a1,n,n,n,10)
	 write(6,*) 'gbar(1)'
         call wrtmat(gbar(1),n,n,n,10)
	 stop
      endif
      call dcopy (n2,gbar(n2p),1,a4,1)
      call dgetrs ('n',n,n,a3,n,ipvt,a4,n,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      if(SYMM) then
      call dgemm ('t','n',n,n,n,-one,gbar(n2p),n,a4,n,one,gbar(nh),n)
      else
      call dgemm ('n','n',n,n,n,-one,gbar(n2r),n,a4,n,one,gbar(nh),n)
      endif
      call dgemm ('n','n',n,n,n,one,a2,n,a4,n,zero,gbar(n2p),n)
*
      call dcopy (n2,a2,1,a4,1)
      call dgetrs ('n',n,n,a3,n,ipvt,a4,n,ier)
      if ( ier .ne. 0 ) then
	 write (iout,1010) ier
	 stop
      endif
      call dcopy (n2,a1,1,gbar,1)
      call dgemm ('n','n',n,n,n,-one,a2,n,a4,n,one,gbar,n)
      if(.not.SYMM) then
      call dcopy (n2,gbar(n2r),1,a1,1)
      call dgemm ('n','n',n,n,n,one,a1,n,a4,n,zero,gbar(n2r),n)
      endif
*
      return
 1000 format (' rpropf : error return from dgetrf, ier = ',i4)
 1010 format (' rpropf : error return from dgetrs, ier = ',i4)
      end
      subroutine rpropi (en,du,e,dchan,n,nmax,gbar,a1,a2,tev,tpev,prg)
      implicit integer (a-z)
      integer n,i,ij,n2,j,nmax,nh,n2p
      double precision dchan,tev,tpev,gbar,zero,one,a1,a2,en,du,e,ek,
     x                 hek,s,sh,ch
      parameter ( zero=0.0d0,one=1.0d0 )
      dimension tev(nmax,n),tpev(nmax,n),dchan(n*2),gbar(n*n*4),a1(n*n),
     x          a2(n*n),en(n)
      LOGICAL SYMM,prg
      COMMON /XPROP/ SYMM,NSURF
*
*     initialize global propagators
*
      do 10 i = 1, n
	 ek = e - en(i)
	 if ( i .gt. nsurf) then
           dchan(i) = zero
	   dchan(n+i) = zero
         else 
	   if ( ek .ge. zero ) then
	    ek = sqrt(ek)
	    hek = du * ek
	    s = - one
	    sh = sin(hek)
	    ch = cos(hek)
	   else
	    s = one
	    ek = sqrt(-ek)
	    hek = du * ek
	    sh = sinh(hek)
	    ch = cosh(hek)
	   endif
	   dchan(i) = one / ( s * sh * ek )
	   dchan(n+i) = ch * dchan(i)
	 endif
   10 continue
*     o11 = s22 = dchan(n+1); s12 = s21 = dchan
*     g11 = gbar; g12 = gbar(n2p); g22 = gbar(nh); g21 = gbar(n2r)
*     initialize modified global r-matrices
      n2 = n * n
      n2p = n2 + 1
      nh = n2 + n2p
      n2r = n2 + nh
      do 20 ij = 1, n2
         j = (ij-1)/n + 1
         i = ij - (j-1) * n
         a1(ij) = dchan(n+i) * tpev(i,j)
         a2(ij) = dchan(i) * tpev(i,j)
   20 continue
      call dgemm ('n','n',n,n,n,one,tev,nmax,a1,n,zero,gbar,n)
      call dgemm ('n','n',n,n,n,one,tev,nmax,a2,n,zero,gbar(n2p),n)
      call dcopy (n2,gbar,1,gbar(nh),1)
      if(.not.SYMM) call dcopy (n2,gbar(n2p),1,gbar(n2r),1)
	if(prg) then
	 i=4
	 if(SYMM) i=3
         do 30 k=1,i
         write(6,*) 'rpropi: GBAR(**,',k,') at initialisation:'
 30        call wrtmat(gbar(1+(k-1)*n2),n,n,n,10)
	endif
      return
      end
      subroutine slwpot (nstart,n,nmax,
     x                   prntv,debug,rstart,rfinal,lwsect,lwkeep,lwran,
     x                   beta,cuplim,ipmax,
     x                   lchl,cf,mchan,ethr,idiscr,diaflg,
     x			 rstep,wfrmax,lwgf,symm,nblock,efermi)
      implicit integer (a-z)
      double precision vmat,enrg,tc,tp,tsave,rstart,cf,ethr,rlim,stp,
     x                 rfinal,drstrt,stpmin,stpmax,beta,work,tev,tpev,
     x                 expt,zero,one,half,dr,rl,step,r,e1,couple,vprime,
     x                 or,rr,oe1,cupest,cuplim,lwsect,rstep,wfrmax,
     x		       rnext,vval,err,eps,efermi,estep
      logical prntv,debug,symm,diaflg
      parameter ( zero=0.0d0,one=1.0d0,half=0.5d0,expt=1.0d0/6.0d0 )
      parameter ( eps=1d-8)
      dimension vmat(n*n),enrg(nmax),tc(nmax,nmax),tev(nmax,nmax),
     x		tp(nmax,nmax),tsave(nmax,nmax),work(nmax,nmax),
     x		tpev(nmax,nmax),lchl(nmax),cf(mchan,mchan,ipmax),
     x          ethr(nmax),cupest(nmax),rlim(2),stp(2),ipvt(nmax),
     x          lwsect(lwran),lwkeep(lwran),lwgf(lwran)
      common /io/ iin,iout
*
*     slwpot -  diagonalises the potential in each sector
*               nstart = 1 at first entry. On exit,
*               nstart = number of steps taken (nstart can be used to
*               restart slwpot ready to propagate further)
*
*     calculate the first step length using the gradient of the
*     potential at rstart and the max using rfinal
      n2 = n * n
      ik = 1
      if (nstart .gt. 1) ik = 2
	write(3,*) ' SLWPOT: nstart=',nstart
	write(3,*) ' SLWPOT: n,nmax,ipmax=',n,nmax,ipmax
	write(3,*) ' SLWPOT: rstart,rfinal,rstep,=',rstart,rfinal,rstep

      rlim(1) = rstart
      rlim(2) = rfinal
      do 10 k = ik, 2
         call potp (rlim(k),n,vmat,nmax,ipmax,lchl,cf,mchan)
         if (prntv) then
            write (iout,1011) rlim(k)
            call wrtmat(vmat,n,n,nmax,8)
         endif
         call vdiag (vmat,enrg,tc,n,work,nmax,symm,-rlim(k))
c	 call ppblock (enrg,n,nblock,ipvt,work,work(1,nmax))
         e1 = zero
         do 20 i = 1,n
            e1 = e1 + enrg(i)
   20    continue
         vprime = (e1/n) ** 2  
	 if(vprime.eq.0d0) vprime=1d-10
         stp(k) = (beta / vprime) ** expt
   10 continue
      stpmax = stp(2)*3
		write(3,*) ' SLWPOT: vprime,stp(1:2) =',real(vprime),stp
      if (nstart .eq. 1) then
         lwkeep(1) = n
	 lwgf(1) = 0
         stpmin = min(stp(1), rfinal-rstart)
         if(rstep.gt.eps.and.wfrmax.gt.rstart) stpmin=min(stpmin,rstep)
         drstrt = stpmin
         if (diaflg) write (iout,1000) rstart,rfinal,stpmin,stpmax,beta
         call pot (rstart,n,vmat,nmax,ipmax,lchl,cf,mchan,ethr)
         if (prntv) then
            write (iout,1010) rstart
            call wrtmat(vmat,n,n,nmax,8)
         endif
         call vdiag (vmat,enrg,tc,n,work,nmax,symm,rstart)
c	 call ppblock (enrg,n,nblock,ipvt,work,work(1,nmax))
         do 35 ik = 1, n2
            i = (ik-1)/n + 1
            k = ik - (i-1) * n
            tev(i,k) = tc(i,k)
            if(symm) tpev(k,i) = tc(i,k)
            tp(k,i) = tc(i,k)
   35    continue
        if(.not.symm) then
	  do 37 i=1,n
	   do 36 j=1,n
	   work(i,j) = tev(j,i)
36	   tsave(i,j) = zero
37	   tsave(i,i) = one
      	  call dgetrf (n,n,work,nmax,ipvt,ier)
      	   if ( ier .ne. 0 ) then
	 	write (iout,1100) ier
	 	stop
      	   endif
      	  call dgetrs ('n',n,n,work,nmax,ipvt,tsave,nmax,ier)
      	   if ( ier .ne. 0 ) then
	 	write (iout,1110) ier
	 	stop
      	   endif
          call transp (tsave,tpev,n,nmax)
 	endif
         if (debug) write (iout,1020)
         write (idiscr,rec=nstart) rstart,drstrt,tev,tpev
         or = rstart
      else
         read (idiscr,rec = nstart+1) or,rstart,drstrt,(enrg(i),i=1,n),
     x                                ((tp(i,k),i=1,n),k=1,n)
      endif
      olim = lwkeep(nstart)
      lwsect(nstart) = rstart
      rl = rstart
      dr = min(drstrt, rfinal-rstart)
      stpmin = drstrt
      e1 = zero
      do 50 i = 1, n
         e1 = e1 + enrg(i)
   50 continue
      e1 = e1 / n
	estep = drstrt
!	write(3,*) 'SLWPOT: starting with step:',real(drstrt)
	rnext = rstart + rstep
      do 500 nstep = nstart+1, lwran
         r = rl + half * dr
         rr = rl + dr
         lwsect(nstep) = rr
	 lwgf(nstep) = 0
	 write(3,51) nstep,rl,rr,dr,estep
	 if(nstep.le.nstart+4.or.debug) write(6,51) nstep,rl,rr,dr,estep
   51    format('  LW sector ',i4,' r= ',2f12.4,' of width ',2f9.4)
         call pot (r,n,vmat,nmax,ipmax,lchl,cf,mchan,ethr)
         if (prntv) then
            write (iout,1010) r
            call wrtmat(vmat,n,n,nmax,8)
         endif
         call vdiag (vmat, enrg, tc, n, work, nmax,symm,r)
c	 call ppblock (enrg,n,nblock,ipvt,work,work(1,nmax))
         if (debug.and.prntv) call printm ('tc  ',tc,n,n,nmax)
         do 95 ixy = 1, n2
            ix = (ixy-1)/n + 1
            iy = ixy - (ix-1) * n
            tev(ix,iy) = tc(ix,iy)
            if(symm) tpev(iy,ix) = tc(ix,iy)
   95    continue
        if(.not.symm) then
	  do 97 i=1,n
	   do 96 j=1,n
	   work(i,j) = tev(j,i)
96	   tsave(i,j) = zero
97	   tsave(i,i) = one
      	  call dgetrf (n,n,work,nmax,ipvt,ier)
      	   if ( ier .ne. 0 ) then
	 	write (iout,1100) ier
	 	stop
      	   endif
      	  call dgetrs ('n',n,n,work,nmax,ipvt,tsave,nmax,ier)
      	   if ( ier .ne. 0 ) then
	 	write (iout,1110) ier
	 	stop
      	   endif
          call transp (tsave,tpev,n,nmax)
 	endif
         oe1 = e1
         e1 = zero
         do 110 i = 1, n
            e1 = e1 +  enrg(i) 
  110    continue
         e1 = e1 / n
*     construct adiabatic overlap coupling matrix
        call dgemm ('n','n',n,n,n,one,tp,nmax,tc,nmax,zero,tsave,nmax)
c       if (debug) call printm ('tsve', tsave,n,n,nmax)
        call dcopy (n*nmax,tpev,1,tp,1)
        write (idiscr,rec = nstep) rl, dr, enrg, tsave , tev , tpev
*
*     estimate the coupling between each channel with higher channels
         lim = 0
         j2 = 0
         do 100  j = 2, n
            j2 = j2 + 2
            cupest(j) = zero
            do 105  k = 1, j - 1
               cupest(j) = cupest(j) + tsave(j,k) * tsave(j,k)  +  
     x                     tsave(k,j) * tsave(k,j)
  105       continue
            cupest(j) = sqrt(cupest(j)) / (dble(j2) * dr)
            if (cupest(j) .gt. cuplim) lim = j
  100    continue
         if (lim .lt. olim) then
            lim = olim - 1
         elseif (lim .gt. olim) then
            do 115 i = nstep-1, 1, -1
               lwkeep(i) = max (lwkeep(i),lim)
  115       continue
         endif
         lwkeep(nstep) = lim
         olim = lim
         nprnt = min(n,2)
         if (debug) then
            couple = zero
            do 120 i = 1, n
               couple = couple + abs( tsave(i,i) )
  120       continue
            couple = one - couple / dble(n)
            write (iout,1040) nstep, rl, r, rr, dr, couple,
     x                        (enrg(i),i=1,nprnt)
         endif
*     next step size code
         vprime = ( ( oe1 - e1 ) / ( or - r ) )**2
	    if(vprime.eq.0d0) vprime=1d-10
         step = ( beta / vprime )**expt
		estep = step
!		write(3,*) ' SLWPOT: vprime,step =',real(vprime),step
         step = max( step, stpmin )
         step = min( step, stpmax )
*     to force propogation to end at rfinal, uncomment next statement
         step = min( step, rfinal-rr )
		if(rstep.gt.eps.and.rr.le.abs(wfrmax)+eps) then
*					force some sectors to end at
*					multiples of rstep (up to wfrmax)
                  step = min( step, rstep)
		if(rr.lt.rnext-eps) then
		  step = min( step, rnext-rr)
		 else
		  rnext = rnext + rstep
	 	  lwgf(nstep) = 1
		 endif
		 if(wfrmax.lt.0.) step = rstep/max(1,nint(rstep/step))
		endif
         or = r
         rl = rr
         if (rr .ge. rfinal) then
            nstart = nstep
            go to 510
         endif
         dr = step
  500 continue
      nstart = lwran
  510 write (idiscr,rec = nstep+1) or,rl,dr,enrg,tpev
	 write(6,515) nstart,rr
  515    format('  Last LW sector ',i4,' to r= ',f12.6/)
      if (diaflg) write (iout,1050) nstep,step
      return
*
 1000 format (' R-Matrix Propagation : Light-Walker Method',/,
     x	      ' Initial radius =',f10.5,5x,'; Final radius   =',f10.5,/,
     x	      ' Min. step size =',e15.5,   '; Max. step size =',e15.5,/,
     x	      ' Beta =',e15.5)
 1010 format (' Potential at r =',f10.5)
 1011 format (' Potential derivative at r =',f10.5)
 1020 format ( '1Light-Walker Propagation',/,' nstep ',
     x	       ' r(left)  r(cntr)  r(rght)     step coupling',
     x	       ' Lowest potl evalues:..' )
 1040 format ( i6, 3f9.3, f9.4, f9.4, 1p2e11.3 )
 1050 format (' nstep =',i5,5x,'step =',f15.6)
 1100 format (' slwpot : error return from dgetrf, info = ',i6)
 1110 format (' slwpot : error return from dgetrs, info = ',i6)
      end
      subroutine transp ( a, b, n, nmax )
      implicit integer (a-z)
      double precision   a, b
      dimension a(nmax,n), b(nmax,n)
*
*     transp -- copies the transpose of a(nmax,n) to b(nmax,n)
*
      n2 = n * n
      do 10 ij = 1, n2
         i = (ij-1)/n + 1
         j = ij - (i-1)*n
         b(j,i) = a(i,j)
   10 continue
      return
      end

      subroutine ppblock (e,n,nblock,ior,iw,ew)
      integer n,ior,IFAIL
      double precision e,eblock,ew
      common /io/ iin,iout
      dimension e(n),ior(n),ew(n),iw(n)
	IFAIL = 0
	call m01ajf(e,ew,ior,iw,n,n,IFAIL)
*			Set blocked levels to 100 MeV = 5 ry
	eblock = 5.0
*			Set blocked levels to largest eigenenergy found.
	eblock = e(ior(n))
	call chops(122)
	do 10 i=1,nblock
	write(122,*) ' Block eigenenergy ',e(ior(i)),' @',ior(i)
10	e(ior(i)) = eblock
	return
	end

      subroutine vdiag (v,e,t,n,work,nmax,symm,r)
      integer n,nmax,info,iin,iout
      double precision v,e,t,work,r,X,XLIM,RL
      common /io/ iin,iout
      dimension e(n), t(nmax,n), work(2*n), v(nmax,nmax),iwork(n)
      logical symm
      real*8 scent,ryev
      common /cent/ scent,ryev
      RL(X,XLIM) = max(-XLIM,min(XLIM,x))
*
* if symm:
*     v(n,n)     real symmetric matrix to be diagonalized
* else:
*     v(n,n)     real NONsymmetric matrix to be diagonalized
*		 but if nonsymmtric, all eigenvalues still real!
*     e(n)	eigenvalues of v
*     t(nmax,n) eigenvectors of v
*
	   call chops(120)
	   call chops(121)
	   info=-1
	if(symm) then
C Ax=Ex all
c          previously: call DSPEV ( 'V', 'U', N, v, e, t, nmax, WORK, INFO )

	   call F02ABF(v,nmax,n,e,t,nmax,work,info)
	 if(r.gt.0d0) then
	   write(120,55) r,(e(i)*ryev,i=1,min(n,10))
!	   write(120,56) r,(RL(e(i)*ryev,100d0),i=1,min(n,10))
!eadr	   write(121,55) r,(e(i)*r*r-scent*(scent+1.),i=1,min(n,10))
55	   format(g12.4,1p,11e12.4)
56	   format(g12.4,   11f8.3)
	   call flush(120)
	   call flush(121)
	  endif
	else 
C find all eigensolutions of unsymmetric matrix problem Ax=Ex
C with F02AGFR (modified F02AGF for real eigenvalue cases)
           call f02agfr(v,nmax,n,e,work,t,nmax,.true.,iwork,info)

	if(r.gt.0d0) then
	   do 60 i=1,n
	   if(abs(work(i)).gt.1d-8) then
		call chops(118)
		write(118,61) r,e(i),work(i)
		endif
60	   continue
61         format(1p,3e12.4)
	   write(120,55) r,(e(i),i=1,min(n,10))
!	   write(120,56) r,(RL(e(i),100d0),i=1,min(n,10))
	   write(121,55) r,(e(i)*r*r-scent*(scent+1.),i=1,min(n,10))
	  endif
	endif
	
      if ( info .ne. 0 ) then
         write (iout,1000) info,r,symm
         stop
      endif
      return
*
 1000 format (' vdiag : error return after diagonalisation, info =', i3,
     X		' at r =',f9.3,l3)
      end
      SUBROUTINE WRONSK2 (NC,NOP,F,FP,I0M,ET,ERRMAX)
      IMPLICIT INTEGER (A-Z)
      REAL*8 F,FP,EPS,ZERO,SUM,TSUM,E,FMAX,EE,ERRMAX,max,ET(NC)
      common /IE/ EE,IERR
      real*8 scent,ryev,SKJ
      common /cent/ scent,ryev
      PARAMETER ( ZERO=0.0D0)
      COMMON /IO/ IIN,IOUT
      DIMENSION F(NC,NC,2),FP(NC,NC,2)
*
*     CHECK MULTICHANNEL WRONSKIAN RELATIONS
*
c	write(47,*) 'WR: NC,NOP,I0M:',NC,NOP,I0M
	call chops(45)
	SKJ = sqrt(abs(EE)/ryev)
      TSUM = ZERO
      ERRMAX = 0.0
      DO 100 I0 = 1, I0M
         IF (I0 .EQ. 2) TSUM = 1d0
         DO 90 J1 = 1, NC
            DO 80 J2 = 1, NC
		SKJ = abs(ET(J1)*ET(J2)) ** 0.25d0
               SUM = ZERO
               FMAX = ZERO
               IF (J1 .EQ. J2 .AND. J1 .LE. NOP) SUM = - TSUM
               DO 70 I = 1, NC
	   if(abs(F(I,J2,I0)).gt.1d100) 
     x	       write(45,50) I0,J1,J2,I,FP(I,J1,1),F(I,J2,I0),F(I,J1,1),
     X                 FP(I,J2,I0),SUM
   50		format(4i3,1p,5e15.7)
                  SUM = SUM + (FP(I,J1,1) * F(I,J2,I0) - F(I,J1,1) *
     X                 FP(I,J2,I0))/SKJ
                  FMAX = max(FMAX,abs(FP(I,J1,1)*F(I,J2,I0)),
     X                            F(I,J1,1)**2,F(I,J2,I0)**2,
     X                            abs(F(I,J1,1)*FP(I,J2,I0)))
   70          CONTINUE
               if(FMAX.ne.0d0) ERRMAX = max(ERRMAX,abs(SUM)/FMAX)
c 		write(47,*) ' I0,J1,J2:',I0,J1,J2,ERRMAX
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
c	write(47,*) ' ERRMAX:',ERRMAX
      RETURN
      END
      SUBROUTINE WRONSK3 (NC,NOP,F,FP,I0M,ET,ERRMAX)
      IMPLICIT INTEGER (A-Z)
      REAL*8 F,FP,EPS,ZERO,SUM,TSUM,E,FMAX,EE,ERRMAX,max,ET(NC)
      common /IE/ EE,IERR
      real*8 scent,ryev,SKJ,er
      common /cent/ scent,ryev
      PARAMETER ( ZERO=0.0D0)
      COMMON /IO/ IIN,IOUT
      DIMENSION F(NC,NC,2),FP(NC,NC,2),ERRMAX(2,nc)
*
*     CHECK MULTICHANNEL WRONSKIAN RELATIONS
*
 	call chops(47)
c	write(47,*) 'WR: NC,NOP,I0M:',NC,NOP,I0M
	SKJ = sqrt(abs(EE)/ryev)
      TSUM = ZERO
      DO 100 I0 = 1, I0M
         DO 10 J2 = 1, NC
10      ERRMAX(I0,J2) = 0.0
         IF (I0 .EQ. 2) TSUM = 1d0
         DO 90 J1 = 1, NC
            DO 80 J2 = 1, NC
		SKJ = abs(ET(J1)*ET(J2)) ** 0.25d0
               JJ = max(J1,J2)
               SUM = ZERO
               FMAX = ZERO
               IF (J1 .EQ. J2 .AND. J1 .LE. NOP) SUM = - TSUM
               DO 70 I = 1, NC
                  SUM = SUM + (FP(I,J1,1) * F(I,J2,I0) - F(I,J1,1) *
     X                 FP(I,J2,I0))/SKJ
                  FMAX = max(FMAX,abs(FP(I,J1,1)*F(I,J2,I0)),
     X                            F(I,J1,1)**2,F(I,J2,I0)**2,
     X                            abs(F(I,J1,1)*FP(I,J2,I0)))
   70          CONTINUE
	       er = 0d0
               if(FMAX.ne.0d0) er = abs(SUM)/FMAX
	       ERRMAX(I0,JJ) = max(ERRMAX(I0,JJ),er)
		if(er.gt.1d-3.and.er.gt.ERRMAX(I0,JJ)*0.95)  then
     		write(47,75) EE,I0,J1,J2,ERRMAX(I0,JJ),er,sum,fmax
               SUM = ZERO
               FMAX = ZERO
               IF (J1 .EQ. J2 .AND. J1 .LE. NOP) SUM = - TSUM
		do 73 I=1,NC
                  SUM = SUM + FP(I,J1,1) * F(I,J2,I0) - F(I,J1,1) *
     X                 FP(I,J2,I0)
                  FMAX = max(FMAX,abs(FP(I,J1,1)*F(I,J2,I0)),
     X                            F(I,J1,1)**2,F(I,J2,I0)**2,
     X                            abs(F(I,J1,1)*FP(I,J2,I0)))
   		write(47,76) I,FP(I,J1,1) , F(I,J2,I0) , F(I,J1,1) ,
     X                 FP(I,J2,I0),SUM,FMAX,sum/max(FMAX,1d-100)
   73          CONTINUE
		endif
   75  	format(' EE,I0,J1,J2:',f8.3,3i4,1p,2e12.3,2x,2e12.3)
   76  	format( I4,4g12.4,2x,3g12.4)
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
c	write(47,*) ' ERRMAX:',((ERRMAX(I0,J2),J2=1,5),I0=1,I0M)
      RETURN
      END
      subroutine cpk2(n,f2,fp2,r,sk,eta,fl,nmax)
      implicit integer (a-z)
      integer n
      double precision f2,fp2,r,sk,eta,k,kr
      double precision fx,fxp,fl
      dimension sk(nmax),eta(nmax)
*
      k = abs(sk(n))
      kr = k * r
      f2 = exp(- kr + abs(eta(n)) * log(kr+kr)) 
      fp2 = - (k - abs(eta(n)) / r) * f2
      call coul (fl,-eta(n)*k,k,r,fx,fxp)
      write(3,*) 'Pickup ch',n,' at',real(r),': ',real(f2),real(fp2/f2),
     x            real(fx),real(fxp/fx)
      f2 = fx 
      fp2= fxp 
      return
      end
