#	sturmxx: for f95   Version 92
#
#	Ian J. Thompson,     I.Thompson@surrey.ac.uk
#July 2006
#	
#

####            PC FTN90:
#F90C = ftn90
# O = obj
# E = .exe
# LINK = link77 sturmx87.lk
# INST = move /y sturmxx.exe ..\run
# RM = DEL
# ARCH = pc
# #FFLAGS = /check_sub/debug
# FFLAGS = 
# FFLAGS1 = /fixed 
# FFLAGS3 = /fixed 

####            NAG f95:
FC = f95
F90C = $(FC) -w
FFLAGS = -O2
# FFLAGS = -g -stackvar
FFLAGS0 = 
FFLAGS1 = -O2
FFLAGS3 = -O2
LFLAGS =  -O2
# LFLAGS =   -g
LIBS =  
O = o
E =
LINK = $(F90C) $(LFLAGS) -o sturmxx $(STURMXOBJ) $(LIBS) 
INST = install sturmxx $(HOME)/bin/$(ARCH)
#INST = install sturmxx$(E) /opt/PHS1IT/bin
RM = rm -f
####            

# FFLAGS =  
UTIL = $(ARCH)util.$(O)
MISC = $(ARCH)io.$(O)
# Self-contained mathematics:
MATH1 = nag1.$(O) nag2.$(O) bls.$(O) bls2.$(O) dlamch.$(O) nag4.$(O) nag.$(O)
# If nag library available:
MATH2 = dlamch.$(O) nag2ext.$(O)
# If nagdx library available:
MATH3 = nag2ext.$(O)

#   defaults in compilation directory `arch`/, overriding MATH sometimes
####include defaults
# Since 'include' does not work on PC, here are the PC defaults:
MATH = $(MATH1)

PHASE = tmat91.$(O) 
XLR  = lwp89.$(O) xlr86.$(O) asym89.$(O) galf84.$(O) xmisc86.$(O) \
	xlrndf77.$(O) bound84.$(O) 

SCAT = rmatr87.$(O)  kmatm89.$(O) belmag91.$(O) coulfg5.$(O) spbe88.$(O)\
	scatt92.$(O) fadbas81.$(O) contwf88.$(O) consf82.$(O) rrcoe.$(O) sim9j.$(O) \
	 asywfn89.$(O) conacsf90.$(O) conasf90.$(O) conden91.$(O)  fival.$(O) \
	$(XLR) $(PHASE) 
#SCAT = scatdum.$(O) 

LAG = qualag.$(O) rootlag.$(O) polag.$(O) lagnorm.$(O)
STURMXOBJ= global92.$(O) readcc92.$(O) input92.$(O) sturm92.$(O) prob92c.$(O) \
	search8.$(O) search9.$(O) vvread89.$(O) pripot91.$(O)\
	wrtmat.$(O) denanr91.$(O) wraca.$(O) integ45.$(O) \
	invitr6.$(O) coul.$(O) makemt90.$(O) basis90.$(O) \
	$(MISC) $(SCAT) $(MATH) $(LAG)

sturmxx$(E): $(STURMXOBJ)
	$(LINK)
install: sturmxx$(E)
	ls -l sturmxx$(E)
	size sturmxx$(E)
	$(INST)

nag1.o: nag1.f
	$(F90C) $(FFLAGS3) -c nag1.f
nag2.o: nag2.f
	$(F90C) $(FFLAGS3) -c nag2.f
nag4.o: nag4.f
	$(F90C) $(FFLAGS3) -c nag4.f
bls.o: bls.f
	$(F90C) $(FFLAGS3) -c bls.f
bls2.o: bls2.f
	$(F90C) $(FFLAGS3) -c bls2.f
dou.o: dou.f
	$(F90C) $(FFLAGS3) -c dou.f
basis90.o: basis90.f
	$(F90C) $(FFLAGS3) -c basis90.f
makemt90.o: makemt90.f
	$(F90C) $(FFLAGS3) -c makemt90.f
bound84.o: bound84.f
	$(F90C) $(FFLAGS1) -c bound84.f
dlamch.o: dlamch.f
	$(F90C) $(FFLAGS0) -c dlamch.f

objs: $(STURMXOBJ)

tar:
	tar -cvhf sturmxx92.tar *.f makefile* *.lk *.fs *.tex
	gzip sturmxx92.tar
installtar: tar
	install sturmxx92.tar.gz ftp

asywfn89.$(O): global92.$(O) asywfn89.f
basis90.$(O): global92.$(O) basis90.f
belmag91.$(O): global92.$(O) belmag91.f
bound84.$(O): global92.$(O) bound84.f
conasf90.$(O): global92.$(O) conasf90.f
conacsf90.$(O): global92.$(O) conacsf90.f
conden91.$(O): global92.$(O) conden91.f
consf82.$(O): global92.$(O) consf82.f
contwf88.$(O): global92.$(O) contwf88.f
denanr91.$(O): global92.$(O) denanr91.f
galf84.$(O): global92.$(O) galf84.f
lwp89.$(O): global92.$(O) lwp89.f
input92.$(O): global92.$(O) input92.f
makemt90.$(O): global92.$(O) makemt90.f
pripot91.$(O): global92.$(O) pripot91.f
prob92c.$(O): global92.$(O) prob92c.f
readcc92.$(O): global92.$(O) readcc92.f
rmatr87.$(O): global92.$(O) rmatr87.f
scatt92.$(O): global92.$(O) scatt92.f
spbe88.$(O): global92.$(O) spbe88.f
sturm92.$(O): global92.$(O) sturm92.f
tmat91.$(O): global92.$(O) tmat91.f
vvread89.$(O): global92.$(O) vvread89.f
xlr86.$(O): global92.$(O) xlr86.f

F90FLAGS = $(FFLAGS)
#.f90.obj:
#	$(F90C) $(FFLAGS)  $<
.f.obj:
	echo Compile $<
	$(F90C) /fixed $(FFLAGS)  $<
.f.o:
	$(F90C) -c $(FFLAGS)  $<

bls.obj: bls.f
	ftn90 /fixed bls.f
dlamch.obj: dlamch.f
	ftn90 /fixed dlamch.f
coulfg5.obj: coulfg5.f
	ftn90 /fixed coulfg5.f


#########
clean :
	$(RM) *.$(O) 
	$(RM) core
	$(RM) sturmxx$(E)
	$(RM) *.M
	$(RM) *.mod
	$(RM) *.mix
