	Subroutine MakeMatrix(Nstate,alpha,SS,VVsturm,AA,MM,OnlyMM,
     x                  fvec,p,esturm,failed)
	use globals
	use pauli
	implicit real*8 (a-h,o-z)
	real*8 VVsturm(numrmax)
	real*8 SS(nchmax,numrmax),alpha(nchmax)
	real*8 AA(nchmax,nchmax),MM(nchmax,nchmax),NN
	real*8 fvec(nchmax),fMM(nchmax),fAL(nchmax),fAR(nchmax),
     X		p(nchmax)
	logical OnlyMM,esturm,failed(nchmax)
c --------------------------------------------
c       matrix elements for MM=<SS|SS> delta(lji)
c --------------------------------------------
 	do k1=1,nch
          kv1=(k1-1)/nsturm
	  do k2=1,k1
	    kv2=(k2-1)/nsturm
 	    MM(k1,k2)=0
            if (kv1.eq.kv2) then
	    do i=1,numr
	      MM(k1,k2)=MM(k1,k2)+wrad(i)*SS(k1,i)*SS(k2,i)
	    enddo
	    endif
            MM(k2,k1)=MM(k1,k2)
          enddo
	enddo

	if(prmats.and.pralpha) then
	   write(6,*) 'MM normalisation matrix:'
	   call wrtmat(MM,nch,nch,nchmax,6)
 	 endif	
	if(OnlyMM) then
	   do 10 nocc=1,NSRC
10	   read(14)
	   return
	endif
c --------------------------------------------
c       matrix elements for AA=<SS|V2|SS>*YY2
c --------------------------------------------
	do 30 k1=1,nch
	do 30 k2=1,nch
30	AA(k1,k2) = 0d0
 	do kv1=1,Nstate
	do kv2=1,Nstate
	  do i=1,numr
              VV = VVAL(kv1,kv2,rrad(i)) * wrad(i)
	      if(pertcent.and.kv1.eq.kv2) 
     & 		 VV = VV + wrad(i) *ryev*
     &             ( (LCHL(kv1)+scent)*(LCHL(kv1)+scent+1d0)
     &                - scent*(scent+1d0) )/rrad(i)**2
	    do l1=1,nsturm
	      k1=(kv1-1)*nsturm+l1
	      VV1 = VV * SS(k1,i)
	      k20 = (kv2-1)*nsturm
	      l2max = min(nsturm,k1 - k20)
	      if(.not.symm) l2max = nsturm
c					l2max so k2.le.k1 if symm.
	    do l2=1,l2max
	      k2=k20+l2
		AA(k1,k2) = AA(k1,k2) + SS(k2,i) * VV1
             enddo
             enddo
	  enddo
	enddo
	enddo
	if(symm) then
	do 35 k1=1,nch
	do 35 k2=1,k1-1
35	AA(k2,k1) = AA(k1,k2) 
	endif
c -----------------------------------------------------
c       matrix elements for AA=l.h.s of the generalized
c				eigenvalue equation
c -----------------------------------------------------

	if(sturm(kst).eq.'T') then
C----------------------------- STURMIANS
 	do k1=1,nch
	  k2min = 1
	  if(symm) k2min = k1
	  do k2=k2min,nch
            EIG = Eo(kst)
	    AA(k1,k2)=AA(k1,k2) + EIG*MM(k1,k2) 
	    if(symm) AA(k2,k1)=AA(k1,k2)
          enddo
	enddo
	else if(sturm(kst).eq.'F') then
C----------------------------- ENERGY EIGENSTATES
 	do k1=1,nch
	  k2min = 1
	  if(symm) k2min = k1
	  do k2=k2min,nch
	  	kh=(k2-1)/nsturm+1
	    AA(k1,k2)=AA(k1,k2)+(alpha(k2)+ECORES(kh))*MM(k1,k2)
           if(symm) AA(k2,k1)=AA(k1,k2)
          enddo
	enddo
	else if(sturm(kst).eq.'L') then
C----------------------------- GAUSS-LAGUERRE BASIS
	aconst = ryev/step**2
 	do k1=1,nch
	  k2min = 1
	  if(symm) k2min = k1
          kv1=(k1-1)/nsturm+1
	  n1 = k1 - (kv1-1)*nsturm
	  do k2=k2min,nch
	    kv2=(k2-1)/nsturm+1
	    if(kv1.eq.kv2) then
	       n2 = k2 - (kv2-1)*nsturm
	       EK = EKIN(n1-1,n2-1,LCHL(kv2),alf)*aconst
	       AA(k1,k2)=AA(k1,k2) + ECORES(kv2)*MM(k1,k2) + EK
              if(symm) AA(k2,k1)=AA(k1,k2)
	    endif
          enddo
	enddo
	endif
c --------------------------------------------
c       matrix elements for NN=<SS|Vo|SS> delta(lji)
c --------------------------------------------
	if(.not.glag) then
 	do k1=1,nch
	  kv1=(k1-1)/nsturm+1
!	   if(sturm(kst).eq.'F'.and.mod(kind,nkind).ne.4
!     X	  		   .or.mod(kind,nkind).eq.2) then
	   if(mod(kind,nkind).eq.2) then
	   	do i=1,numr
	     	VVsturm(i) = VVAL(kv1,kv1,rrad(i)) 
	   	enddo
	   endif
	  k2min = 1
	  if(symm) k2min = k1
	  do k2=k2min,nch
	    kv2=(k2-1)/nsturm+1
          if (kv1.eq.kv2) then
 	    NN=0d0
	    do i=1,numr
	      NN=NN+wrad(i)*SS(k1,i)*SS(k2,i)*VVsturm(i)
	    enddo
	    if(sturm(kst).eq.'T') then
	     AA(k1,k2)=AA(k1,k2)-alpha(k2)*NN
	    else
	     AA(k1,k2)=AA(k1,k2)-NN
	    endif
            if(symm) AA(k2,k1)=AA(k1,k2)
	  endif
          enddo
	enddo
	endif
	do i=1,nch
	  if(failed(i)) AA(i,i) = 1.0
	enddo
c --------------------------------------------
	if(prmats) then
	   write(6,*) 'AA interaction matrix:'
	   call wrtmat(AA,nch,nch,nchmax,6)
 	 endif	
c --------------------------------------------
c       matrix elements for QQAAQQ, 
c	where QQ = 1 - |forbidden><forbidden|
c --------------------------------------------
	if(NSRC.eq.0.or.nch.eq.0)  go to 1000

	call f03aef(nch,MM,nchmax,p,det,idet,ifail)
	do 100 nocc=1,NSRC
	call PauliP(fvec,SS,MM,p,fAL,nocc)
c       Check on the normalization of the forbidden state
	tnorm=0
	do i=1,nch
	  do j=1,nch
	      ijmax = max(i,j)
	      ijmin = min(i,j)
	    tnorm=tnorm+fvec(i)*fvec(j)*MM(ijmin,ijmax)
	  enddo
	enddo
c	if(tnorm.lt.0.5) go to 100
	tnorm=Sqrt(tnorm)
 	write(49,90) nocc,tnorm
90	format(' Norm of ',i3,' occupied state =',F10.6)
 	write(49,91) (fvec(i),i=1,min(10,nch))
91	format(10f9.5)
  	if(tnorm.lt.0.01) then
	 write(6,*) ' Omitting occupied state',nocc,' as norm ',
     x              ' is only ',real(tnorm)
	 go to 100
	endif
	do i=1,nch
	  fvec(i)=fvec(i)/tnorm
	enddo
	aconst=0
	do i=1,nch
	  fMM(i)=0
	  fAL(i)=0
	  fAR(i)=0
	  do j=1,nch
	      ijmax = max(i,j)
	      ijmin = min(i,j)
	    fMM(i)=fMM(i)+MM(ijmin,ijmax)*fvec(j)    
	    fAR(i)=fAR(i)+AA(i,j)*fvec(j)
	    fAL(i)=fAL(i)+AA(j,i)*fvec(j)
	  enddo
	  aconst=aconst+fAR(i)*fvec(i)
	enddo
	Eshift=10000.d0
	aconst = aconst + Eshift
	do i=1,nch
	do j=1,nch
	  AA(i,j)=AA(i,j)-(fMM(i)*fAL(j)+fAR(i)*fMM(j))
     &    +aconst*fMM(i)*fMM(j)
	enddo
	enddo
c	Recover lower triangle of MM lost with the inversion in PauliP
	do i=1,nch
	  do j=1,i-1
	    MM(i,j)=MM(j,i)
	  enddo
	enddo
  100 	continue
	if(prmats) then
	   write(6,*) 'AA'' projected matrix:'
	   call wrtmat(AA,nch,nch,nchmax,6)
 	 endif	
 1000   return
        end
c
c ---------------------------------------------------------------
c
	Subroutine PauliP(fvec,SS,MM,p,rhs,nocc)
	use parameters
	use globals, only: numr,nsturm,onormal,rrad,wrad,nch
	use pauli
	implicit real*8 (a-h,o-z)
	real*8 AA(4)
	real*8 WFfor(MCHAN,nrpp),MM(nchmax,nchmax)
	real*8 SS(nchmax,numrmax),fvec(nchmax),rhs(nchmax),p(nchmax)
	integer chans(MCHAN)
c
	  MCHP = nch/nsturm
	do 10 i=1,MCHP
	  if(.not.occ2) chans(i)=i
	do 10 j=1,NRPP
10	WFfor(i,j) = 0d0
	if(occ2) then
	  read(14,err=121) MCHP,jmin,jmax,(chans(i),i=1,MCHP),
     & 		   ((WFfor(chans(i),j),j=jmin,jmax),i=1,MCHP)
        write(49,11) nocc,jmin,jmax,MCHP 
11      format(/' Reading forbidden state',i3,', jmin,jmax,MCHP = ',3i4)
	else
	  read(14,err=120) ((WFfor(i,j),j=1,NRPP),i=1,MCHP)
	  jmin=1
	  jmax=NRPP
	endif
	do 12 k=1,nch
12	  rhs(k)=0
	do 40 nr=1,numr
	  r=rrad(nr)
          PP = (r - PPRO)/PPDR
	  if(PP+1.gt.jmax.or.PP+1.lt.jmin) go to 40
	  call splint(PP,NRPP,II,NP,AA)
	  do ki=1,MCHP
	    kp = chans(ki)
	    GG=0.0
	    do i=1,NP
		GG = GG + AA(i)*WFfor(kp,II+i-1)
	    enddo
	    GG = GG*wrad(nr)
	    do n=1,nsturm
	      k = (kp-1)*nsturm + n
	      rhs(k)=rhs(k)+GG*SS(k,nr)
	    enddo
	  enddo
40	continue
c	write(49,*) ' Expanded in local basis:'
c	write(49,91) (rhs(i),i=1,nch)
91	format(10f9.5)
	if(.not.onormal) then
		call f04agf(nch,1,MM,nchmax,p,rhs,nch,fvec,nch)
	else
		do k=1,nch
	  	fvec(k)=rhs(k)
		enddo
	endif
	return
120     write(6,*) 'Error in reading forbidden state ',nocc
        write(6,*) 'NRPP,MCHP = ',NRPP,MCHP
	stop
121     write(6,*) 'Error in reading style2 forbidden state ',nocc
        write(6,*) 'Jmin,Jmax,MCHP = ',Jmin,Jmax,MCHP
	stop
   	end
c
c
c
c------------------------------------------------------------
c      Wavefunction Interpolation
c------------------------------------------------------------
        Function WFVAL(IM,RR,WFfor)
	use parameters, only: mchan,numrmax
	use pauli
	implicit real*8 (a-h,o-z)
        PARAMETER(X=.16666666666667d0)
	real*8 WFVAL
	real*8 WFfor(MCHAN,numrmax)
        PP = (RR - PPRO)/PPDR
        I=PP
        IF(I.LE.0) GO TO 2
        IF(I.GE.NRPP-2) GO TO 4
    1   P=PP-I
        P1=P-1.
        P2=P-2.
        Q=P+1.
        WFVAL=(-P2*WFfor(IM,I)+Q*WFfor(IM,I+3))*(P*P1*X)  +    
     x      (P1*WFfor(IM,I+1)-P*WFfor(IM,I+2))*(Q*P2*.5)
        RETURN
    2   IF(I.LT.0) GO TO 3
        I=1
        GO TO 1
    3   WFVAL=0d0
        RETURN
    4   IF(I.GT.NRPP-2) GO TO 5
        I=NRPP-3     
        GO TO 1   
    5   WFVAL=0.D0
        RETURN
	end
      SUBROUTINE SPLINT(PP,N,I,NP,A)
C
C     FIND COEFFICIENTS A(J),J=1,NP FOR SPLINE INTERPOLATION OF A
C          FUNCTION AT 'P'  as sum(J): A(J)*F(I+J-1),J=1,NP
C            F(I+1) HAS THE VALUE AT P=I
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 A(4)
      DATA X/.16666666666667D0/
      P = PP
      I=P
      IF(I.LE.0) GO TO 2
      IF(I.GE.N-2) GO TO 4
    1 P=P-I
      IF(P.EQ.0.) GO TO 10
      P1=P-1.
      P2=P-2.
      Q=P+1.
      C1 = P * P1 * X
      C2 = Q * P2 * .5
C     FF=(-P2*F(I)+Q*F(I+3))*P*P1*X+(P1*F(I+1)-P*F(I+2))*Q*P2*.5
      NP = 4
      A(1) = -P2 * C1
      A(4) =   Q * C1
      A(2) =  P1 * C2
      A(3) =  -P * C2
      RETURN
    2 IF(I.LT.0) GO TO 3
      I=1
      GO TO 1
    3 NP = 1
      I = 1
      A(1) = 1
      RETURN
    4 IF(I.GT.N-2) GO TO 5
      I=N-3
      GO TO 1
    5 NP = 1
      I = N
      A(1) = 1.
      RETURN
   10 NP = 1
      I = I+1
      A(1) = 1.0
      RETURN
      END
