      SUBROUTINE F02AJF(AR,IAR,AI,IAI,N,RR,RI,INTGER,LFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C
C     EIGENVALUES OF A COMPLEX UNSYMMETRIC MATRIX
C     1ST AUGUST 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AJF')
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, LFAIL, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N), RI(N), RR(N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  ACC
      INTEGER           IB, ISAVE, K, L
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF, X02BHF
      EXTERNAL          X02AJF, P01ABF, X02BHF
C     .. External Subroutines ..
      EXTERNAL          F01AMF, F01AVF, F02ANF
C     .. Executable Statements ..
      ISAVE = LFAIL
      LFAIL = 1
      ACC = X02AJF()
      IB = X02BHF()
      CALL F01AVF(N,IB,AR,IAR,AI,IAI,K,L,RR)
      CALL F01AMF(N,K,L,AR,IAR,AI,IAI,INTGER)
      CALL F02ANF(N,ACC,AR,IAR,AI,IAI,RR,RI,LFAIL)
      IF (LFAIL.NE.0) LFAIL = P01ABF(ISAVE,LFAIL,SRNAME,0,P01REC)
      RETURN
      END
      SUBROUTINE F01AMF(N,K,L,AR,IAR,AI,IAI,INTGER)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4.5 REVISED
C     MARK 11 REVISED. VECTORISATION (JAN 1984).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     COMHES
C     GIVEN THE COMPLEX UNSYMMETRIC MATRIX,A, STORED IN THE ARRAYS
C     AR(N,N) AND AI(N,N), THIS SUBROUTINE REDUCES THE
C     SUB-MATRIX OF ORDER L - K + 1, WHICH STARTS AT THE ELEMENTS
C     AR(K,K) AND AI(K,K) AND FINISHES AT THE ELEMENTS AR(L,L)
C     AND AI(L,L), TO HESSENBERG FORM, H, BY NON-ORTHOGONAL
C     ELEMENTARY TRANSFORMATIONS. THE MATRIX H IS OVERWRITTEN ON A
C     WITH DETAILS OF THE TRANSFORMATIONS STORED IN THE REMAINING
C     TRIANGLE UNDER H AND IN ELEMENTS K TO L OF THE ARRAY
C     INTGER(N).
C     1ST AUGUST 1971
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, K, L, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N)
      INTEGER           INTGER(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  XI, XR, YI, YR
      INTEGER           I, J, K1, LA, M, M1, MM
C     .. External Subroutines ..
      EXTERNAL          A02ACF, F01AMY, F01AMZ
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      LA = L - 1
      K1 = K + 1
      IF (K1.GT.LA) RETURN
      DO 140 M = K1, N
         I = M
         XR = 0.0D0
         XI = 0.0D0
         IF (M.GT.L) GO TO 120
         DO 20 J = M, L
            IF ((ABS(AR(J,M-1))+ABS(AI(J,M-1))).LE.(ABS(XR)+ABS(XI)))
     *          GO TO 20
            XR = AR(J,M-1)
            XI = AI(J,M-1)
            I = J
   20    CONTINUE
         INTGER(M) = I
         IF (I.EQ.M) GO TO 80
C        INTERCHANGE ROWS AND COLUMNS OF ARRAYS AR AND AI.
         DO 40 J = K, N
            YR = AR(I,J)
            AR(I,J) = AR(M,J)
            AR(M,J) = YR
            YI = AI(I,J)
            AI(I,J) = AI(M,J)
            AI(M,J) = YI
   40    CONTINUE
         DO 60 J = 1, L
            YR = AR(J,I)
            AR(J,I) = AR(J,M)
            AR(J,M) = YR
            YI = AI(J,I)
            AI(J,I) = AI(J,M)
            AI(J,M) = YI
   60    CONTINUE
   80    IF (XR.EQ.0.0D0 .AND. XI.EQ.0.0D0) GO TO 120
         IF (M.GE.L) GO TO 120
         M1 = M + 1
         DO 100 I = M1, L
            YR = AR(I,M-1)
            YI = AI(I,M-1)
            CALL A02ACF(YR,YI,XR,XI,AR(I,M-1),AI(I,M-1))
  100    CONTINUE
         CALL F01AMZ(AR(1,M+1),IAR,AI(1,M+1),IAI,L,L-M,AR(M+1,M-1)
     *               ,1,AI(M+1,M-1),1,AR(1,M),AI(1,M))
  120    CALL F01AMY(AR(K+1,K),IAR,AI(K+1,K),IAI,L-K,M-K,AR(K+1,M)
     *               ,AI(K+1,M))
  140 CONTINUE
      DO 180 MM = K1, LA
         M = LA - MM + K1
         M1 = M - 2
         I = INTGER(M)
         IF (I.EQ.M) GO TO 180
         IF (K.GT.M1) GO TO 180
         DO 160 J = K, M1
            YR = AR(I,J)
            AR(I,J) = AR(M,J)
            AR(M,J) = YR
            YI = AI(I,J)
            AI(I,J) = AI(M,J)
            AI(M,J) = YI
  160    CONTINUE
  180 CONTINUE
      RETURN
      END
      SUBROUTINE F01AVF(N,IB,AR,IAR,AI,IAI,LOW,LHI,D)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     COMBALANCE
C     REDUCE THE NORM OF A COMPLEX MATRIX AR,AI(N,N) BY
C     EXACT DIAGONAL SIMILARITY TRANSFORMATIONS STORED IN D(N).
C     DECEMBER 1ST.,1971
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, IB, LHI, LOW, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  B2, C, F, G, R, S
      INTEGER           I, J, JJ, K, L
      LOGICAL           NOCONV
C     .. External Functions ..
      DOUBLE PRECISION  A02ABF
      EXTERNAL          A02ABF
C     .. External Subroutines ..
      EXTERNAL          F01AVZ
C     .. Intrinsic Functions ..
      INTRINSIC         DBLE
C     .. Executable Statements ..
      B2 = IB*IB
      L = 1
      K = N
   20 IF (K.LT.1) GO TO 100
C     SEARCH FOR ROWS ISOLATING AN EIGENVALUE AND PUSH THEM DOWN.
      J = K + 1
      DO 60 JJ = 1, K
         J = J - 1
         R = 0.0D0
         DO 40 I = 1, K
            IF (I.EQ.J) GO TO 40
            R = R + A02ABF(AR(J,I),AI(J,I))
   40    CONTINUE
         IF (R.EQ.0.0D0) GO TO 80
   60 CONTINUE
      GO TO 100
   80 CALL F01AVZ(K,AR,IAR,AI,IAI,D,K,L,N,J)
      K = K - 1
      GO TO 20
  100 IF (L.GT.K) GO TO 180
C     SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE AND PUSH THEM
C     LEFT.
      DO 140 J = L, K
         C = 0.0D0
         DO 120 I = L, K
            IF (I.EQ.J) GO TO 120
            C = C + A02ABF(AR(I,J),AI(I,J))
  120    CONTINUE
         IF (C.EQ.0.0D0) GO TO 160
  140 CONTINUE
      GO TO 180
  160 CALL F01AVZ(L,AR,IAR,AI,IAI,D,K,L,N,J)
      L = L + 1
      GO TO 100
C     NOW BALANCE THE SUB-MATRIX IN ROWS L THROUGH K.
  180 LOW = L
      LHI = K
      IF (L.GT.K) GO TO 220
      DO 200 I = L, K
         D(I) = 1.0D0
  200 CONTINUE
  220 NOCONV = .FALSE.
      IF (L.GT.K) GO TO 420
      DO 400 I = L, K
         C = 0.0D0
         R = 0.0D0
         DO 240 J = L, K
            IF (J.EQ.I) GO TO 240
            C = C + A02ABF(AR(J,I),AI(J,I))
            R = R + A02ABF(AR(I,J),AI(I,J))
  240    CONTINUE
         G = R/DBLE(IB)
         F = 1.0D0
         S = C + R
  260    IF (C.GE.G) GO TO 280
         F = F*DBLE(IB)
         C = C*B2
         GO TO 260
  280    G = R*DBLE(IB)
  300    IF (C.LT.G) GO TO 320
         F = F/DBLE(IB)
         C = C/B2
         GO TO 300
  320    IF (((C+R)/F).GE.(0.95D0*S)) GO TO 400
         G = 1.0D0/F
         D(I) = D(I)*F
         NOCONV = .TRUE.
         IF (L.GT.N) GO TO 360
         DO 340 J = L, N
            AR(I,J) = AR(I,J)*G
            AI(I,J) = AI(I,J)*G
  340    CONTINUE
  360    DO 380 J = 1, K
            AR(J,I) = AR(J,I)*F
            AI(J,I) = AI(J,I)*F
  380    CONTINUE
  400 CONTINUE
  420 IF (NOCONV) GO TO 220
      RETURN
      END
      SUBROUTINE F02ANF(NN,ACC,HR,IHR,HI,IHI,WR,WI,LFAIL)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C     MARK 9 REVISED. IER-326 (SEP 1981).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     COMLR
C     FINDS THE EIGENVALUES OF A COMPLEX UPPER-HESSENBERG MATRIX,
C     H, STORED IN THE ARRAYS HR(N,N) AND HI(N,N), AND
C     STORES THE REAL PARTS IN THE ARRAY WR(N) AND THE COMPLEX
C     PARTS IN THE ARRAY WI(N). ACC IS THE RELATIVE MACHINE
C     PRECISION. THE SUBROUTINE FAILS IF ALL EIGENVALUES TAKE MORE
C     THAN 30*N ITERATIONS.
C     1ST DECEMBER 1971
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02ANF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  ACC
      INTEGER           IHI, IHR, LFAIL, NN
C     .. Array Arguments ..
      DOUBLE PRECISION  HI(IHI,NN), HR(IHR,NN), WI(NN), WR(NN)
C     .. Local Scalars ..
      DOUBLE PRECISION  SI, SR, TI, TR, XI, XR, YI, YR, ZI, ZR, ZXI, ZXR
      INTEGER           I, I1, ISAVE, ITN, ITS, J, L, LL, M, M1, MM, N,
     *                  N1
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          A02AAF, A02ACF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      ISAVE = LFAIL
      LFAIL = 0
      N = NN
      TR = 0.0D0
      TI = 0.0D0
      ITN = 30*N
   20 IF (N.EQ.0) GO TO 480
      ITS = 0
C     LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT
   40 L = N + 1
      IF (N.EQ.1) GO TO 80
      DO 60 LL = 2, N
         L = L - 1
         IF ((ABS(HR(L,L-1))+ABS(HI(L,L-1))).LE.(ACC*(ABS(HR(L-1,L-1))
     *       +ABS(HI(L-1,L-1))+ABS(HR(L,L))+ABS(HI(L,L))))) GO TO 100
   60 CONTINUE
   80 L = 1
  100 IF (L.EQ.N) GO TO 460
      IF (ITN.GT.0) GO TO 120
      LFAIL = P01ABF(ISAVE,1,SRNAME,0,P01REC)
      RETURN
C     FORM SHIFT
  120 IF ((ITS.NE.10) .AND. (ITS.NE.20)) GO TO 140
      SR = ABS(HR(N,N-1)) + ABS(HR(N-1,N-2))
      SI = ABS(HI(N,N-1)) + ABS(HI(N-1,N-2))
      GO TO 180
  140 SR = HR(N,N)
      SI = HI(N,N)
      N1 = N - 1
      XR = HR(N1,N)*HR(N,N1) - HI(N1,N)*HI(N,N1)
      XI = HR(N1,N)*HI(N,N1) + HI(N1,N)*HR(N,N1)
      IF ((XR.EQ.0.0D0) .AND. (XI.EQ.0.0D0)) GO TO 180
      YR = (HR(N-1,N-1)-SR)/2.0D0
      YI = (HI(N-1,N-1)-SI)/2.0D0
      CALL A02AAF(YR**2-YI**2+XR,2.0D0*YR*YI+XI,ZR,ZI)
      IF ((YR*ZR+YI*ZI).GE.0.0D0) GO TO 160
      ZR = -ZR
      ZI = -ZI
  160 CALL A02ACF(XR,XI,YR+ZR,YI+ZI,ZXR,ZXI)
      XR = ZXR
      XI = ZXI
      SR = SR - XR
      SI = SI - XI
  180 DO 200 I = 1, N
         HR(I,I) = HR(I,I) - SR
         HI(I,I) = HI(I,I) - SI
  200 CONTINUE
      TR = TR + SR
      TI = TI + SI
      ITS = ITS + 1
      ITN = ITN - 1
      J = L + 1
C     LOOK FOR TWO CONSECUTIVE SMALL SUB-DIAGONAL ELEMENTS
      XR = ABS(HR(N-1,N-1)) + ABS(HI(N-1,N-1))
      YR = ABS(HR(N,N-1)) + ABS(HI(N,N-1))
      ZR = ABS(HR(N,N)) + ABS(HI(N,N))
      M = N
      N1 = N - 1
      IF (J.GT.N1) GO TO 240
      DO 220 MM = J, N1
         M = M - 1
         YI = YR
         YR = ABS(HR(M,M-1)) + ABS(HI(M,M-1))
         XI = ZR
         ZR = XR
         XR = ABS(HR(M-1,M-1)) + ABS(HI(M-1,M-1))
         IF (YR.LE.(ACC*ZR/YI*(ZR+XR+XI))) GO TO 260
  220 CONTINUE
  240 M = L
C     TRIANGULAR DECOMPOSITION H = L*R
  260 M1 = M + 1
      DO 360 I = M1, N
         XR = HR(I-1,I-1)
         XI = HI(I-1,I-1)
         YR = HR(I,I-1)
         YI = HI(I,I-1)
         IF ((ABS(XR)+ABS(XI)).GE.(ABS(YR)+ABS(YI))) GO TO 300
C        INTERCHANGE ROWS OF HR AND HI
         I1 = I - 1
         DO 280 J = I1, N
            ZR = HR(I-1,J)
            HR(I-1,J) = HR(I,J)
            HR(I,J) = ZR
            ZI = HI(I-1,J)
            HI(I-1,J) = HI(I,J)
            HI(I,J) = ZI
  280    CONTINUE
         CALL A02ACF(XR,XI,YR,YI,ZR,ZI)
         WR(I) = 1.0D0
         GO TO 320
  300    CALL A02ACF(YR,YI,XR,XI,ZR,ZI)
         WR(I) = -1.0D0
  320    HR(I,I-1) = ZR
         HI(I,I-1) = ZI
         DO 340 J = I, N
            HR(I,J) = HR(I,J) - ZR*HR(I-1,J) + ZI*HI(I-1,J)
            HI(I,J) = HI(I,J) - ZR*HI(I-1,J) - ZI*HR(I-1,J)
  340    CONTINUE
  360 CONTINUE
C     COMPOSITION R*L = H
      M1 = M + 1
      DO 440 J = M1, N
         XR = HR(J,J-1)
         XI = HI(J,J-1)
         HR(J,J-1) = 0.0D0
         HI(J,J-1) = 0.0D0
C        INTERCHANGE COLUMNS OF HR AND HI, IF NECESSARY
         IF (WR(J).LE.0.0D0) GO TO 400
         DO 380 I = L, J
            ZR = HR(I,J-1)
            HR(I,J-1) = HR(I,J)
            HR(I,J) = ZR
            ZI = HI(I,J-1)
            HI(I,J-1) = HI(I,J)
            HI(I,J) = ZI
  380    CONTINUE
  400    DO 420 I = L, J
            HR(I,J-1) = HR(I,J-1) + XR*HR(I,J) - XI*HI(I,J)
            HI(I,J-1) = HI(I,J-1) + XR*HI(I,J) + XI*HR(I,J)
  420    CONTINUE
  440 CONTINUE
      GO TO 40
C     A ROOT FOUND
  460 WR(N) = HR(N,N) + TR
      WI(N) = HI(N,N) + TI
      N = N - 1
      GO TO 20
  480 RETURN
      END
      SUBROUTINE F01AMY(AR,IAR,AI,IAI,M,N,BR,BI)
C     MARK 11 RELEASE. NAG COPYRIGHT 1983.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     COMPUTES  B = L**(-1) * B  (COMPLEX) WHERE
C     L IS A LOWER TRIANGULAR MATRIX OF THE SPECIAL FORM
C     ( L11  0 )
C     ( L21  I )
C     L11 IS LOWER TRIANGULAR OF ORDER N,
C     L21 IS RECTANGULAR (M-N) BY N.
C     A HOLDS THE SUBDIAGONAL ELEMENTS OF THE FIRST N COLUMNS OF L
C     AND THE DIAGONAL ELEMENTS OF L ARE TAKEN TO BE 1.0 .
C
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N), BI(M), BR(M)
C     .. Local Scalars ..
      DOUBLE PRECISION  XI, XR
      INTEGER           I, J, JP1
C     .. Executable Statements ..
      DO 40 J = 1, N
         JP1 = J + 1
         IF (JP1.GT.M) GO TO 40
         XR = BR(J)
         XI = BI(J)
         DO 20 I = JP1, M
            BR(I) = (BR(I)-AR(I,J)*XR) + AI(I,J)*XI
            BI(I) = (BI(I)-AR(I,J)*XI) - AI(I,J)*XR
   20    CONTINUE
   40 CONTINUE
      RETURN
      END
      SUBROUTINE F01AMZ(AR,IAR,AI,IAI,M,N,BR,IBR,BI,IBI,CR,CI)
C     MARK 11 RELEASE. NAG COPYRIGHT 1983.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     COMPUTES  C = C +  A*B  (COMPLEX) WHERE
C     A IS RECTANGULAR M BY N.
C     C MUST BE DISTINCT FROM B.
C     THE ELEMENTS OF B MAY BE NON-CONSECUTIVE, WITH OFFSETS IBR
C     AND IBI.
C
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, IBI, IBR, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N), BI(IBI,N), BR(IBR,N),
     *                  CI(M), CR(M)
C     .. Local Scalars ..
      INTEGER           I, J
C     .. Executable Statements ..
      DO 40 J = 1, N
         DO 20 I = 1, M
            CR(I) = (CR(I)+AR(I,J)*BR(1,J)) - AI(I,J)*BI(1,J)
            CI(I) = (CI(I)+AR(I,J)*BI(1,J)) + AI(I,J)*BR(1,J)
   20    CONTINUE
   40 CONTINUE
      RETURN
      END
      SUBROUTINE F01AVZ(M,AR,IAR,AI,IAI,D,K,L,N,J)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C
C     AUXILIARY ROUTINE CALLED BY F01AVF
C     INTERCHANGES ELEMENTS 1 TO K OF COLUMNS J AND M,
C     AND ELEMENTS L TO N OF ROWS J AND M.
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, J, K, L, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), AR(IAR,N), D(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  F
      INTEGER           I
C     .. Executable Statements ..
      D(M) = J
      IF (J.EQ.M) GO TO 60
      DO 20 I = 1, K
         F = AR(I,J)
         AR(I,J) = AR(I,M)
         AR(I,M) = F
         F = AI(I,J)
         AI(I,J) = AI(I,M)
         AI(I,M) = F
   20 CONTINUE
      IF (L.GT.N) GO TO 60
      DO 40 I = L, N
         F = AR(J,I)
         AR(J,I) = AR(M,I)
         AR(M,I) = F
         F = AI(J,I)
         AI(J,I) = AI(M,I)
         AI(M,I) = F
   40 CONTINUE
   60 RETURN
      END
      SUBROUTINE A02AAF(XXR,XXI,YR,YI)
C     MARK 2A RELEASE.  NAG COPYRIGHT 1973
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C     MARK 11C REVISED. IER-467 (MAR 1985)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     COMPUTES THE SQUARE ROOT OF A COMPLEX NUMBER
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION  XXI, XXR, YI, YR
C     .. Local Scalars ..
      DOUBLE PRECISION  H, HALF, ONE, XI, XR, ZERO
C     .. External Functions ..
      DOUBLE PRECISION  A02ABF
      EXTERNAL          A02ABF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Data statements ..
      DATA              ZERO/0.0D0/, HALF/0.5D0/, ONE/1.0D0/
C     .. Executable Statements ..
C
      XR = ABS(XXR)
      XI = XXI
      IF (XR.GT.ONE) H = SQRT(XR*HALF+A02ABF(XR*HALF,XI*HALF))
      IF (XR.LE.ONE) H = SQRT(XR+A02ABF(XR,XI))*SQRT(HALF)
      IF (XI.NE.ZERO) XI = XI/(H+H)
      IF (XXR.LT.ZERO) GO TO 20
      YR = H
      YI = XI
      RETURN
   20 IF (XI.LT.ZERO) GO TO 40
      YR = XI
      YI = H
      RETURN
   40 YR = -XI
      YI = -H
      RETURN
      END
