      program sturmxx
      use globals
      use pauli
      use gs
      use scattering
      use gailitis, only: nulim
      IMPLICIT real*8 (A-H,O-Z)
      REAL*8 ZERO,HALF
      PARAMETER ( ZERO=0.0D0,HALF=0.5D0)
      CHARACTER*80 TITLE(2)
      real*8 roin,rostep,ppr0
      CHARACTER*80 fpot,fmel,fspec,focc,fgs
      common /dimrmat/mchan33

      logical open14,FADgs,idens
      NAMELIST /mefile/ fpot
*
      IIN = 5
      IOUT = 6
      IERR = 6
      open14 = .false.
      write(IOUT,1)  
1     format(/' STURMXX, v92a'/)
      GO = .false.
      GONE = .false.
	call memuse
	nulim = 1
*
      READ (IIN,mefile,IOSTAT=IOS,END=2,ERR=2)
   2  IF ( IOS .NE. 0 ) THEN
         WRITE (IOUT,*) 'Read mefile namelist: IOS =',IOS
         WRITE (IOUT,mefile)
         STOP
      ENDIF
c     WRITE (IOUT,mefile)
c      read(IIN,*) fpot
       fmel =fpot(1:lnblnk(fpot))//'.mel'
       fspec=fpot(1:lnblnk(fpot))//'.spec'
       focc =fpot(1:lnblnk(fpot))//'.occ'
       fgs =fpot(1:lnblnk(fpot))//'.gs'
       fgs ='fort.77'
       write(IOUT,*)  'Opening files: ',
     x        fmel(1:lnblnk(fmel)),',',fspec(1:lnblnk(fspec))
            open (12,file = fmel,access = 'sequential',
     x         form='unformatted',status = 'old')
            open (13,file =fspec,access = 'sequential',
     x         form='formatted',status = 'old')

      write(IOUT,*) 
      write(IOUT,*) '** Information from these files:'
      read(13,1030) TITLE(1)
      write(IOUT,1035) TITLE(1)
      read(13,*) ryev,coulcn
      write(IOUT,*) '   Energy scale: 1 Ry  = ',real(ryev)
      write(IOUT,*) '   Coulomb scale: e^2  = ',real(coulcn)
      rmt = 1d0/ryev
      READ(13,*) ROIN,ROSTEP,NROOO,PPR0,PPDR,NRPP,RINNER
      WRITE(IOUT,*) '   Coupling potentials : roin,rostep,nrooo = ',
     x               real(ROIN),real(ROSTEP),NROOO
      WRITE(IOUT,*) '   Projection operators: ppr0,ppdr,nrpp    = ',
     x               real(PPR0),real(PPDR),NRPP
      WRITE(IOUT,*) '                         rinner = ',real(RINNER)
      read(13,*) nbody,scent,lxtra,ncoup,ipmax,mfad,symm,details,npots,
     X			mtarg,nmom
        nbod = nint(2d0*scent)/3+2
	if(nbod.ne.abs(nbody)) then
	  write(IOUT,*) ' Scent = ',real(scent),' is INCONSISTENT ',
     X		'with ',abs(nbody),' bodies!'
	  if(nbody>0) write(IOUT,*) 
     X		' To continue regardless, enter nbody =',-nbody
	  if(nbody>0) stop
	endif
	nbody = abs(nbody)
	 nogscat = nbody.ge.3
	 eeigmax = 50.
	 if(nbody==2) eeigmax = 5000.
	mfad = max(mfad,1)
	npots = max(npots,1)
	npots = min(npots,10)
        WRITE(IOUT,*) '   Scent =',real(scent),',  LXTRA =',LXTRA,
     x	'  for  ',nbody,'-body problem'
 	WRITE(IOUT,*) '   Number of: Faddeev components = ',mfad,
     X	   ',  Coupling rules = ',ncoup
        WRITE(IOUT,*) '              Inverse powers = ',ipmax,
     X	   '   with ',npots,' potential components'
        WRITE(IOUT,*) '              Core details = ',details,
     X	   '   with ',nmom,' wf moments'
	if(nmom>0) write(IOUT,'(''  Moment orders ='',20i3)') nlam(1:nmom)
	fad = mfad.eq.2 .or. mfad.eq.3
	fad = .not.symm
        alf = 2.*(1. + scent)
	npair = nbody*(nbody-1)/2
	allocate (radius(nbody),iso(npair),id(npair),qnum(lxtra+1),
     X	 Qmom(nbody),Mmom(nbody),CoreK(nbody),energy(mtarg,nbody),
     X   mult(lxtra+1),npstates(nbody),nparity(mtarg,nbody),name(nbody),
     X	 nucl(nbody,mfad),cupord(3,ncoup),mass(nbody),charge(nbody))
	potcoef(:) = 1d0

	read(13,'(30a3)') qnum(1:lxtra+1)
	write(IOUT,'(/''    Quantum numbers :'',30a3)') qnum(1:lxtra+1)
	read(13,'(30i3)') mult(1:lxtra+1),jgt
	write(IOUT,'(''     for multipliers:'',30i3)') mult(1:lxtra+1)
	if(ncoup>0) then
	   read(13,'(20i3)') ((cupord(i,j),i=1,3),j=1,ncoup)
	   write(IOUT,'(/''    Coupling rules :'',20i3)') 
     X			((cupord(i,j),i=1,3),j=1,ncoup)
	   write(IOUT,103) ((qnum(cupord(i,j)),i=1,3),j=1,ncoup)
103	   format('           ::',20(a3,' +',a3,' =',a3,:,';'))
	if(jgt>0) then
	   write(IOUT,*) '        Total spin: quantum number ',qnum(jgt)
         endif
!		Find order of coupling 2nd and 3rd quantum numbers (L+S)
	slorder = 0  ! unknown
	do j=1,ncoup
	 if(cupord(1,j)==2 .and. cupord(2,j)==3) slorder = 1  ! LS order
	 if(cupord(1,j)==3 .and. cupord(2,j)==2) slorder = 2  ! SL order
	 enddo
	 if(slorder==1) write(IOUT,*) '        Coupling in LS order'
	 if(slorder==2) write(IOUT,*) '        Coupling in SL order'
	   
	endif
	if(details) then
	read(13,*) mass,charge,radius
! 	write(IOUT,*) mass,charge,radius
	 
	tmass = 0d0
	do ib=1,nbody
	read(13,1045) name(ib),npstates(ib),corek(ib),Qmom(ib),Mmom(ib),
     X    (energy(i,ib),nparity(i,ib),i=1,npstates(ib))
! 	write(*,1045) name(ib),npstates(ib),corek(ib),Qmom(ib),Mmom(ib),
!     X    (energy(i,ib),nparity(i,ib),i=1,npstates(ib))
1045    format(a8,i3,f4.1,2f10.4,10(f8.4,i4))
!     X         (8x,3x,4x,20x,10(f8.4,i4)))
      	IF ( npstates(ib) .gt. MTARG ) THEN
         WRITE (IOUT,1025) npstates(ib), MTARG
         STOP
      	ENDIF
	tmass = tmass + mass(ib)
	enddo
        WRITE(IOUT,1079) (name(i),i=1,nbody)
 1079 FORMAT(/4X,'NUCLEI: ',2x,20(3x,a8))
        WRITE(IOUT,1080) (i,mass(i),i=1,nbody)
 1080 FORMAT(4X,'Masses:  ',20(' A',i1,'=',F8.1,:,','))
        WRITE(IOUT,1081) (i,charge(i),i=1,nbody)
 1081 FORMAT(4X,'Charges: ',20(' Z',i1,'=',F8.1,:,','))
        WRITE(IOUT,1082) (i,radius(i),i=1,nbody)
 1082 FORMAT(4X,'Radii:   ',20(' R',i1,'=',F8.3,:,','))
        WRITE(IOUT,1083) (npstates(i),i=1,nbody)
 1083 FORMAT(4X,'# states:',20('  ',1x,'=',i8,:,','))
        WRITE(IOUT,1084) (i,corek(i),i=1,nbody)
 1084 FORMAT(4X,'Rotation:',20(' K',i1,'=',F8.1,:,','))
        WRITE(IOUT,1085) (i,Qmom(i),i=1,nbody)
 1085 FORMAT(4X,'Q moment:',20(' Q',i1,'=',F8.3,:,','))
        WRITE(IOUT,1086) (i,Qmom(i),i=1,nbody)
 1086 FORMAT(4X,'M moment:',20(' m',i1,'=',F8.3,:,','))
	do ib=1,nbody
         write(IOUT,1090) npstates(ib),name(ib),
     X		(energy(i,ib),psign(nparity(i,ib)+2),i=1,npstates(ib))
 1090 format(4X,'   The',i4,' states of ',a8,':',/
!    X		5(f8.4,' MeV (',a1,')',:,';'),/,
     X		(10x,5(f8.4,' MeV (',a1,')',:,';')))
	enddo
	  
	read(13,*) (id(i),iso(i),i=1,npair)
!	write(IOUT,*) 'id,iso =',(id(i),iso(i),i=1,npair)
	idens = .false.
	do ip=1,npair
	 if(id(ip)) then
	    n1 =  mod(ip,nbody)+1
  	    n2 =  mod(ip+1,nbody)+1
  	   write(IOUT,1098)  n1,name(n1),n2,name(n2),iso(ip)
1098	   format('   Isospin of nucleus ',i1,'=',a8,' with ',i1,'=',a8,
     X 		' is ',f4.1)
	   idens = .true.
	 endif
	 if(npair>=3) tt = iso(3)
	 ttnc = iso(1)
	enddo
	 if(.not.idens) 
     X		write(IOUT,*) '    No identical particles notified'
	if(mfad>1.and.details) then
	read(13,*) ((nucl(j,i),j=1,nbody),i=1,mfad)
	write(IOUT,1096) 
1096    format(/'   Core labelling in Faddeev components:')
	do i=1,mfad
	write(IOUT,1095) i,fads(i),(nucl(j,i),name(nucl(j,i)),j=1,nbody)
1095	format('     in ',i1,' (',a1,'), ICHL(:,1:3)'
     X	 ,' in order ',5(i2,'=',a8,:,','))
	enddo
	 else
	  do j=1,nbody
	  nucl(j,1) = j
	  enddo
	endif
!			end of details block
	endif

      etap = 0d0
	if(nbody==2) then
          etap = coulcn * charge(1)*charge(2) / ryev
          write(IOUT,*) '    Two-body CF/ryev=etap=2k.eta = ',real(etap)
	else  if(details) then
	 Pi  = 4d0*atan(1d0)
         ZEFF=0d0
         do i=1,nbody
         do j=1,i-1
         ZEFF = ZEFF+ charge(i)*charge(j)
     X			* sqrt(mass(i)*mass(j)/(mass(i)+mass(j)))
     X                  * 16/(3*PI)
         enddo
         enddo
          etap = coulcn * zeff / ryev
          write(IOUT,*) '    Three-body zeff =',real(zeff), 
     X			' etap=2k.eta = ',real(etap)
	endif
C
      open (48,access = 'sequential',form='unformatted',
     x		     status = 'scratch')
C  READ FROM stdin:
      write(IOUT,*) 
      write(IOUT,*) '** Information from namelist input file:'

	call InputSturm
	meigs0 = meigs
     	nccset = 0

C	If file 77 present, read PsiGSe and set GO (=gs obtained)
            open (77,file =fgs,access = 'sequential',
     x         form='unformatted',status = 'old',err=8)
	    call readgs(77,fgs,FADgs)
     	    nccset = nccset+1
	    go to 10
   8	    write(6,*) '   Could not open file ',fgs(1:lnblnk(fgs))

  10  nccset = nccset+1
      if(nccset.gt.maxset.and.maxset.gt.0) then
      write(IOUT,*) 'Only ',maxset,' coupled channels sets to be solved'
	stop
	endif
      READ(13,1030,end=99) TITLE(2)
      write(IOUT,1035) TITLE(2)
      READ(13,11) JJ2,NPTY,NCHAN,mintl,XLA,ESCATT
  11	format(4i5,f10.5,e12.4)
      jtot = JJ2*0.5d0
      parity = npty
c      write(6,*) JJ2,NPTY,NCHAN,XLA,jtot
      NCHAN3 = NCHAN
      write(IOUT,1040) jtot,PSIGN(NPTY+2),NCHAN
      if(mintl>0) write(IOUT,1041) mintl,ESCATT
      if(XLA.ne.0.) write(IOUT,1042) XLA
      if(FAD) then
	  fadex = max(fadex,1)
	  fadex = min(fadex,3)
	 if(asymp) fadex = max(fadex,2)
	  write(IOUT,111) fadex
  111     format('  for Faddeev wfns projected onto ',i1,' components')
c	  if(asymp) write(IOUT,*) '  ASYMPTOTIC EXPANSIONS DISABLED!'
c	  asymp = .false.
	 else
	  fadex = 1
	 endif
      mchan = nchan
      mchan3 = mchan
      mchan33 = mchan3
	allocate (lchl(mchan),kfad(mchan),icop(mchan))
	allocate (lxtr(lxtra,mchan),ecores(mchan))
	if(details) allocate (ichl(mchan,nbody))
	if(mintl>0) allocate (initl(mintl))
      DO 12 I=1,NCHAN
	icop(i) = 0
   12  KFAD(I) = 1
      if(details) then
      READ (13,*) (KFAD(I),I=1,NCHAN)
	WRITE(6,'(''KFAD:'',25x,5i4)') (KFAD(I),I=1,min(NCHAN,5))
      do ib=1,nbody
      	READ (13,*) (ICHL(I,ib),I=1,NCHAN)
	WRITE(6,'(''ICHL:'',i4,21x,5i4)') (ib,ICHL(I,ib),I=1,min(NCHAN,5))
	enddo
      else
	do i=1,NCHAN
	KFAD(i) = 1
	enddo
        write(6,*) 'KFAD:',KFAD(1:NCHAN)
      endif
      READ (13,*) (LCHL(I),I=1,NCHAN)
	WRITE(6,'(''LCHL:'',25x,5i4)') (LCHL(I),I=1,min(NCHAN,5))
      DO 18 IX=1,LXTRA
      write(6,*) ' Now read in extra set ',IX
      call flush(6)
      READ (13,*) (LXTR(IX,I),I=1,NCHAN)
	WRITE(6,'(''X'',i4,25x,5i4)') IX,(LXTR(IX,I),I=1,min(NCHAN,5))
   18 continue
  181	continue
!			Find sum of core energies in each channel:
      KKMAX=0
      do i=1,NCHAN
	ec = 0d0
      	if(details) then
	do ib=1,nbody
	  ec = ec + energy(ichl(i,ib),nucl(ib,kfad(i)))
	enddo
	endif
	ecores(i) = ec
	KKMAX=max(KKMAX,nint(lchl(i)+scent+1.5))      
      enddo
   15 FORMAT(1x,a3,':',18I4,:,/(5x,18i4))
  151 FORMAT(1x,1x,a1,i1,':',18I4,:,/(5x,18i4))
   16 FORMAT(1x,a3,':',18A4,:,/(5x,18A4))
   20 FORMAT(1x,a3,':',18I4,:,/(5x,18i4))
   21 FORMAT(1x,a3,':',18f4.1,:,/(5x,18f4.1))

      NCHAN3 = NCHAN
      IF (FAD.and.fadex.eq.1) THEN
c			Find reduced number of T basis channels
        NCHAN3 = 0
        do 27 I=1,NCHAN
27       if(KFAD(I).eq.1) NCHAN3 = I
      ENDIF
	nrow = 18
      DO 30 I1=1,NCHAN,nrow 
	NCHL = min(I1+nrow-1,NCHAN)     
      WRITE(IOUT,15)
      WRITE(IOUT,15) 'ch#',(I,I=I1,NCHL)
      if(details) then
      if(mfad>0) WRITE(IOUT,16) 'fad',(FADS(KFAD(I)),I=I1,NCHL)
	do ib=1,nbody
      	 WRITE(IOUT,151) 'i',ib,(ICHL(I,ib),I=I1,NCHL)
	enddo
	endif
      WRITE(IOUT,15) qnum(1),(LCHL(I),I=I1,NCHL)
      DO 29 IX=1,LXTRA
      if(mult(ix+1).eq.1) then
 	WRITE(IOUT,20) qnum(IX+1),(LXTR(IX,I),I=I1,NCHL)
	else
        WRITE(IOUT,21)qnum(IX+1),(LXTR(IX,I)/real(mult(ix+1)),I=I1,NCHL)
	endif
   29 continue
      if(details) WRITE(IOUT,21)' E*',(ecores(I),I=I1,NCHL),real(mintl)
   30 continue
      if(MINTL>0) then
	READ (13,*) (initl(I),I=1,mintl)
	write(6,15) 'in@',(initl(I),I=1,mintl)
   	endif
	write(6,*) 'read NSRC,NKILL:'
        READ(13,*) NSRC,NKILL
        write(6,*) 'NSRC,NKILL:',NSRC,NKILL
	occ2 = NSRC .lt. 0
	NSRC = abs(NSRC)
	NBLOCK = NKILL
	if(MBLOCK.ge.0) NBLOCK = min(NKILL,MBLOCK)
	if(NSRC.ne.0) then
	  write(IOUT,40) NSRC,occ2,NKILL,NBLOCK
   40     format(/' Orthogonalising to ',I4,' forbidden configurations',
     x         L3,' from',I3,' channels; blocking',I3/)
	if(.not.open14)  then
            open (14,file = focc,access = 'sequential',
     x         form='unformatted',status = 'old')
	    open14 = .true.
	    endif
	endif
        kst = 1
        if(nccset.gt.1) kst = 2
C now to work: read potentials --
        call vvread(nchan,nchan3,roin,rostep,nrooo,kst)
        if(pripot) call pripots(nchan,nrooo,roin,rostep)

	kind = kindi
	if(kindi==9) then
	  if(sturm(kst).eq.'T') kind = 0
	  if(sturm(kst).ne.'T') kind = 2
	endif
	if(sturm(kst).eq.'T') write(IOUT,801)  Eo(kst),kind
801	format(/'  Eo =',F8.3,'  with Sturmians in  potential kind',I2)
	if(sturm(kst).eq.'L') write(IOUT,802)  Eo(kst)
802       format(/'  Eo =',F8.3,'  with Laguerre Basis')
	if(sturm(kst).eq.'F') write(IOUT,803)  Eo(kst),kind
803      format(/'  Eo =',F8.3,'  with Energy Eigenstates in ',
     x				'potential kind',I2)

	nulim = numax
	if(mintl>0.or..not.nogscat) nulim = numax
	   if(asymp) write(IOUT,22) rafin,nulim
22	format(/'   Propagate (LW) wave functions to ',f10.3,' fm',/,
     &	       '   then with numax =',i2,' Galaitis couplings')
	   if(.not.asymp) 
     & 	  write(IOUT,*) '   No asymptotic coupled wave functions'

C now to work: diagonalise --
	nch = nchan*nsturm
	nchmax = nch
	meigs = meigs0
	if(meigs.le.0) meigs = nch
	call sturmians(NCHAN,NCHAN3)
	call memuse

	i = nulim
	nulim = numax
	if(nulim/=i) write(IOUT,*) ' Galaitis power reset to ',nulim
	if(rmaxsc.lt.Rmax) then
	   Rmax = rmaxsc
	   asymp = rafin .gt. Rmax
	   if(asymp) rafin = max(rafin,wfrmax)
	   numr = nint(Rmax/stepi)
	   numrs1= nint(Rmax/steps)
	   write(IOUT,804) numr,stepi,Rmax,numrs1,numrs
804	   format('   Internal expansion limited to',I4,' steps of',
     x		F8.4,' fm, up to ',F8.3,' fm.',/,
     X      '         numrs1, numrs=',2i4/)
	   endif
	deallocate (lchl,kfad,icop,lxtr,wn1,mp12,cf,ecores,moms)
	if(details) deallocate (ichl)
	if(mintl>0) deallocate (initl)
      GO TO 10
   99 STOP
*
 1020 FORMAT (' READCC : INPUT ERROR, NCHAN = ',I4,' MCHAN =',I4)
 1021 FORMAT (' READCC : INPUT ERROR, NCHAN3 = ',I4,' MCHAN3 =',I4)
 1025 FORMAT (' READCC : INPUT ERROR, NTARG = ',I4,' MTARG =',I4)
 1030 FORMAT (A80)
 1035 FORMAT (/1x,A80/)
 1040 FORMAT (/'J,pi =',F5.1,A1,' with ',I3,' channels'/)
 1041 FORMAT ( '      with ',I3,' incoming channels at ',f10.3,' MeV.'/)
 1042 FORMAT ( '      with parameter ',f10.5)
      END
	subroutine readgs(nf,fgs,FADgs)
        use globals
	use gs
      	IMPLICIT real*8 (A-H,O-Z)
      	CHARACTER*80 fgs
	logical FADgs
	integer,allocatable:: it(:)

	write(6,*) 'Reading gs wfn from file ',fgs(1:lnblnk(fgs))
	read(nf) egs,nstgs,lxtgs,jtoti,PARITI,TTGS,
     X		nbody,FADgs,numgs,stepgs
        write(6,5) egs,jtoti,PSIGN(PARITI+2),nstgs,TTGS
5       format(/' Ground state ENGY =',F13.8,' MeV  (',F5.1,A1,') with',
     X		I4,' channels and T =',I2,':'/)
	write(6,*) ' Number of bodies: ',nbody,'; Faddeev gs: ',FADgs,
     x	 '; lxtgs =',lxtgs
        write(6,*) ' numgs: ',numgs,'; stepgs: ',real(stepgs)

	numrd = min(numgs,numrs)
	if(abs(steps-stepgs).gt.1e-6) then
		write(6,*) ' Gs wfn defined for step size ',real(stepgs),
     x		 ' but step ',real(steps),' required now!'
		stop
		endif
 	write(6,*)  ' Reading ',numrd,' wf points'
       	XAPL =sqrt(abs(egs)/ryev)
	allocate (kfadgs(nstgs),kstgs(nstgs,lxtgs+1),ichgs(nstgs,nbody))
	allocate (PsiGSe(nstgs,numrs),it(nstgs))
	do 6 i=1,nstgs
	read(nf) (ichgs(i,ib),ib=1,nbody),(kstgs(i,j),j=1,lxtgs+1)
c	write(6,*) ' Read file ',nf,', i,K =',i,kstgs(i,1)
	if(FADgs) read(nf) kfadgs(i)
      	read(nf) (PsiGSe(i,irs),irs=1,numrd)
 	do 6 irs=numrd+1,numrs
 	PsiGSe(i,irs) = PsiGSe(i,numrd)*
     X		exp(-XAPL*(rrade(irs)-rrade(numrd)))
6	continue
	numgs = numrs
	write(6,*)  ' Storing gs wfn up to Rmax =',real(numgs*stepgs)
	mchan=nstgs
	mchan3=nstgs
	mchan33=nstgs

	write(6,*) 
      if(.not.FADgs) then
      DO 12 I=1,nstgs
c       KFAD(I) = 1
   12  kfadgs(I) = 1
	endif

	nrow = 18
      DO 30 I1=1,nstgs,nrow 
	NCHL = min(I1+nrow-1,nstgs)     
      WRITE(IOUT,15)
      WRITE(IOUT,15) 'ch#',(I,I=I1,NCHL)
      if(FADgs) WRITE(IOUT,16) 'fad',(FADS(kfadgs(I)),I=I1,NCHL)
   15 FORMAT(1x,a3,':',18I4,:,/(5x,18i4))
  151 FORMAT(1x,1x,a1,i1,':',18I4,:,/(5x,18i4))
   16 FORMAT(1x,a3,':',18A4,:,/(5x,18A4))
	do ib=1,nbody
      WRITE(IOUT,151) 'i',ib,(ichgs(I,ib),I=I1,NCHL)
	enddo
      WRITE(IOUT,15) qnum(1),(kstgs(I,1),I=I1,NCHL)
      DO 29 IX=1,lxtgs
   29 WRITE(IOUT,15) qnum(IX+1),(kstgs(I,IX+1),I=I1,NCHL)
   30 continue
	   ITT=0
	   do i=1,nstgs
	    if(kfadgs(i).eq.1) then
		ITT = ITT+1
		it(ITT) = i
	 	endif
	   enddo
	   write(IOUT,*) ' with ',ITT,' T-basis channels'
	GO = .true.

C
c --------------------------------------
c         rms radius of g.s.
c --------------------------------------
	rms = 0.0
	rmq = 0.0
	sum = 0.0
	do i=1,nstgs
          g=4.d0/3.d0
	  if(kfadgs(i).eq.1) then
	do irs=1,numgs
	   T = PsiGSe(i,irs)**2 * stepgs*g
	   sum = sum + T
	   rms    = rms + rrade(irs)**2 * T
	   rmq    = rmq + rrade(irs)**4 * T
            g=2d0-g
	enddo
	  endif
	enddo
	  write(IOUT,*) ' and T-basis normalised to ',real(sum)
	rms = rms / sum
	rmq = rmq / sum
	if(details) then
	  if(nbody.ge.3) then
	   T = 0d0
	   do ib=1,nbody
	     T = T + mass(ib)*radius(ib)**2
	   enddo
	   rmstot=sqrt((T + rms)/tmass)
	  else if(nbody.eq.2) then
	 rmstot=Sqrt(mass(2)/tmass*radius(2)**2 + mass(2)/tmass**2 *rms)
          endif
	else
	 rmstot=rms/nbody
	 rmstot=0d0
	endif
	if(details) then
	   write(6,52) sqrt(rms),rmq**0.25d0,rmstot,radius
	else
	   write(6,52) sqrt(rms),rmq**0.25d0
	endif
52	format( ' Rms wf =',f7.3,' fm.  Rmq wf =',f7.3,' fm. ',/,
     x    :,    ' So rms Matter radius =',F7.3,' fm.',:,
     x		' with radii = ',10F7.3/)
	  
	if(nbody.eq.3) then
	   call denanr(PsiGSe,steps,numgs,rrade,wrade,
     x				kstgs,nstgs,kfadgs,egs)
	   endif
C
        if(lprwf.ge.1) then
C
C	write out g.s. wavefunction, file 11 for plotting, file 18 binary:
      	   write(11,4001) egs,(it(i),i=1,min(ITT,10))
4001  	   format('# Bound State wf at',f10.5,' MeV,',
     X		' chs',10i4)
      	   do 4120 irs=4,numgs,4
4120  	   write(11,4121) rrad(irs),(PsiGSe(it(iti),irs),
     X				iti=1,min(ITT,10))
4121  	   format(1x,f8.3,10f9.5)
      	   write(11,*) '&'
	endif

C Write to file 48 the g.s. wavefunction:
	write(6,*) ' Rewriting g.s. to file 48' 
     	write(48) ((PsiGSe(i,irs),irs=1,numgs),i=1,nstgs)

	return
	end
	subroutine chops(nu)
	logical op
 	inquire(nu,opened=op)
  	if(nu/=3) write(3,*) ' File ',nu,': opened =',op
 	if(.not.op) open (nu,access = 'sequential',form='formatted',
     x		status = 'unknown')
	return
	end
	subroutine chopb(nu)
	logical op
	inquire(nu,opened=op)
	if(.not.op) open (nu,access = 'sequential',form='unformatted',
     x		status = 'unknown')
	return
	end
