c----------------------------------------------
c
	Subroutine Rmatrix(Nstate,SS,alpha,VAL,Rmat,E1,f,fp,
     x             phi,phib,ebutc,nebut,Nstate3,esturm,VVsturm,AA)
	use globals
	use gs
	use scattering
	implicit real*8 (a-h,o-z)
	real*8 SS(nchmax,numrmax),VAL(nchmax),VVsturm(numrmax)
	real*8 alpha(nchmax),f(Nstate,Nstate,2),fp(Nstate,Nstate,2)
	real*8 phi(MCHAN,nchmax),phib(MCHAN3),phi3(MCHAN3)
	real*8 Rmat(MCHAN3,MCHAN3),butc(MCHAN3),AA(nchmax,nchmax)
     X	 ,ebutc(nmaxb,MCHAN3,2),logd,Psi0(numrmax),Rsp(MCHAN3)
	real*8,allocatable:: rhs(:,:)
	integer nebut(MCHAN3),ipiv(nch)
	logical esturm
	pi = 4d0*atan(1d0)
C
C****************************************************** R matrix
	do 1 i=1,Nstate3
	do 1 j=1,Nstate3
   1	  Rmat(i,j) = 0.0	

	if(neigs>0) then
        do 21 k=1,neigs
          call Permut(Nstate,Nstate3,phi(1,k),phib)
          do 20 i=1,Nstate3
          do 20 j=1,Nstate3
   20    Rmat(i,j) = Rmat(i,j) + ryev*phi(i,k)*phib(j)
     X                             /(VAL(k)-E1)/Rmax
   21  	continue
	else if(.not.simeq) then
C************************************************ Use ADW R-matrix:
          do 25 i=1,Nstate 
   25	  Rmat(i,i)=f(i,i,1)/(Rmax*fp(i,i,1))
	else
C************************************************ Use sim.eqs. for R-matrix:
c  print matrices to file:
	write(199,*) E1,nch
	do i=1,nch
	  write(199,*) (AA(i,j),j=1,nch)
	enddo


c			L.U decomposition of Hamiltonian matrix
	  do i=1,nch
	   AA(i,i) = AA(i,i) - E1
	  enddo
	  call dgetrf(nch,nch,AA,nchmax,ipiv,info)
	   if(info.ne.0) then
	     write(6,*)' Singular Matrix for this energy',info
	     stop 'Rmatr'
	   endif
	  allocate (rhs(nch,Nstate))
	  rhs(:,:) = 0d0
	  do 30 n=1,nsturm
	  do 30 i=1,Nstate
            k = (i-1)*nsturm + n
	    rhs(k,i) = SS(k,numr)
   30	  continue

	  i=1
	  write(199,*) 'RHS # ',i
	  write(199,*) (rhs(k,i),k=1,nch)

          call dgetrs('N',nch,Nstate,AA,nchmax,ipiv,rhs,nch,info)
	   if(info.ne.0) then
	     write(6,*)' Singular Matrix decomposition for this energy'
	     stop 'Rmatr'
	   endif
	  do 40 i=1,Nstate
	  do 40 j=1,Nstate
	   t = 0d0
	   do 35 n=1,nsturm
            k = (i-1)*nsturm + n
   35	   t = t + SS(k,numr) * rhs(k,j)
	   Rmat(i,j) = t * ryev/Rmax
   40	  continue
	  i=1
	  write(199,*) 'SOL # ',i
	  write(199,*) (rhs(k,i),k=1,nch)
	  deallocate(rhs)
	endif

	if(prrm) then
	   write(6,*) ' r*R matrix:'
          do 43 i=1,Nstate3
   43      write(6,45) i,(Rmax*Rmat(i,j) , j=1,Nstate3)
   45	   format(1x,i3,18f8.3,:,/(4x,18f8.3))
	   write(6,*) ' r*R matrix diagonal (before Buttle correction):'
   	   write(6,45) Nstate3,(Rmax*Rmat(j,j) , j=1,Nstate3)
	  endif
C
	if(buttle.gt.0) then
C**************************************** Interpolated Buttle Correction
	do 50 i=1,Nstate3
	EB = E1-ecores(i)
	if(EB.lt.0.0) go to 50
c
C 	Correct diagonal elements of full R-matrix:

	Rmati  = Rmat(i,i) 
	butc(i) = fival(EB,ebutc(1,i,1),ebutc(1,i,2),nebut(i))
	Rmat(i,i) = Rmati + butc(i)

	if(prbut)
     x	write(1,48) EB,i,Rmati,butc(i),Rmat(i,i)
   48   format(' E,ch =',f8.4,i3,' R,buttle=',2f10.5,' =>',f10.5)
   50   continue
	if(prbut) write(33,55)  EB,(butc(i),i=1,min(Nstate3,10))
   55   format(f8.4,10f10.6)
	else if(buttle.lt.0) then
C********************************************** `Exact' Buttle Correction
	do 150 j=1,Nstate3
        i = j
        if(icop(j).ne.0) i = icop(j)
c
c       Calculate exact wave function for e.g. diagonal potential
C	at an energy EB not too close to single-channel R-matrix energy
	EB = E1-ecores(j)
	if(EB.lt.0.0) go to 150
	do 120  n=1,nsturm-1
          k = (i-1)*nsturm + n
	if(abs(alpha(k)-EB).lt.abs(alpha(k+1)-alpha(k))*0.1) 
     x  EB = alpha(k) + sign(0.1d0,EB-alpha(k))*(alpha(k+1)-alpha(k))
  120	continue
 
          cen = LCHL(i)+scent
          if(pertcent) cen = scent
        call integ3(i,cen,numr,stepi,ryev,EB/ryev,Psi0,logd,
     X		    esturm,VVsturm)
        Rmat0 = 0.0
          do 145 n=1,nsturm
          k = (i-1)*nsturm + n
          if(eeigmax.gt.1..and.alpha(k).gt.eeigmax) go to 145
         Rmat0 = Rmat0 + ryev*SS(k,numr)**2/(alpha(k)-EB)/Rmax
  145    continue
C
        Rex0 = 1d0/(Rmax*(logd - beta))
        phi3(j)=Rex0
        Rsp(j)=Rmat0

C 	Correct diagonal elements of full R-matrix:
	kk = (j*(j-1))/2 + j

	Rmati  = Rmat(i,i) 
	Rmat(i,i) = Rmati + Rex0 - Rmat0

	if(prbut) write(1,148) EB,j,Rmati,Rex0 , Rmat0,Rmat(i,i)
  148   format(' E,ch =',f8.4,i3,' R,buttle=',3f10.5,' =>',f10.5)
  150   continue
	endif
	if(prrm.and.buttle.ne.0) then
	   if(buttle.lt.0) then
	   write(6,*) ' Exact uncoupled r*R matrix diagonal:'
   	   write(6,45) Nstate3,(Rmax*phi3(j) , j=1,Nstate3)
	   write(6,*) ' Calculated uncoupled r*R matrix diagonal:'
   	   write(6,45) Nstate3,(Rmax*Rsp(j) , j=1,Nstate3)
	   endif
	   write(6,*) ' r*R matrix diagonal (with Buttle correction):'
   	   write(6,45) Nstate3,(Rmax*Rmat(j,j) , j=1,Nstate3)
	  endif
	return
	end
c
	Subroutine Permut(Nstate,Nstate3,phi,phib)
	use globals
	implicit real*8 (a-h,o-z)
	real*8 phi(MCHAN),phib(MCHAN3)
c
C	Projection onto each component     -> phib
C		(phi and phib can be same array).

          do 10 i=1,Nstate
   10         phib(i) =  phi(i)
	if(fadex.ge.2) then
          do 16 i=1,Nstate3
          t = 0.0
          do 15 j=1,Nstate3
   15     t = t + wn1(i,j) * phi(j)
   16      phib(i) = t
	endif
	return
	end
